#################################
#
#  External filebase engine ----
#    this library will allow any other script read/write to/from a
#    Sitestat 4.3+ compatible uploads database
#
#    fbe::INIT
#    fbe::ADD area dir mode user timestamp
#    fbe::DEL area dir
#    fbe::GET area dir mode
#    fbe::GETX area dir
#    fbe::NADD area dir nuker reason other owner
#    fbe::NGET area dir
#    fbe::NGETX area dir nuker
#    fbe::FLUSH
#    fbe::CLEAN force
#    fbe::skipcheck area dir
#    fbe::nukecheck area dir
#    fbe::fixstr string
#    fbe::dbg
#
#################################
set FBEVER "5.0.10"

package provide fbe $FBEVER 

namespace eval fbe {

namespace export INIT GET GETX ADD DEL FLUSH CLEAN skipcheck fixstr
#################################################### begin code.
set cac 0
proc dbg {} {
  upvar #0 arealist arealist
  variable uploadsdb
  variable dupecfg
  variable nukesdb
  variable nukecfg
  upvar #0 udb_age agelimit
  variable fbprocess
  variable fbdeletes
  variable nbdeletes
  variable dexemptions
  variable nukerules
  variable uautonuke
  variable cac
  putlog "variable list:"
  putlog "> arealist $arealist"
  putlog "> agelimit $agelimit"
  putlog "array name list:"
  putlog "> fbprocess [array names fbprocess]"
  putlog "> fbdeletes [array names fbdeletes]"
  putlog "> nbdeletes [array names nbdeletes]"
  putlog "specific:"
  foreach type [array names fbprocess] { if {$type==""} {break} ; putlog "> fbp : $fbprocess($type)" }
  foreach type [array names fbdeletes] { if {$type==""} {break} ; putlog "> fbd : $fbdeletes($type)" }
  foreach type [array names nbdeletes] { if {$type==""} {break} ; putlog "> nbd : $nbdeletes($type)" }
}

proc INIT {defskin} {
  upvar #0 arealist arealist
  variable uploadsdb
  variable dupecfg
  variable nukesdb
  variable nukecfg
  upvar #0 udb_age agelimit
  variable fbprocess
  variable fbdeletes
  variable nbdeletes
  variable dexemptions
  variable nukerules
  upvar #0 NEW NEW
  upvar #0 NUKE NUKE
  upvar #0 NUKS NUKS
  upvar #0 CID3 CID3
  upvar #0 DEL DEL
  upvar #0 UNNK UNNK
  upvar #0 INCD INCD
  upvar #0 PRE PRE
  upvar #0 DATE DATE
  upvar #0 DELA DELA
  upvar #0 RACE RACE
  upvar #0 SFV SFV
  upvar #0 DUPE DUPE
  upvar #0 HALF HALF
  upvar #0 COMP COMP
  upvar #0 MISC MISC
  set nowtime [clock seconds]
  set uploadsdb "_udb.ss"
  set dupecfg "_dc.cfg"
  set nukesdb "_nks.ss"
  set nukecfg "_nc.cfg"
  set skincfg "_skin.cfg"
  set reve "*"
  set fbprocess(ss:x4) "dummy"
  set fbdeletes(ss:x4) "dummy"
  set nbdeletes(ss:x4) "dummy"
################### temp files cleanup
  set files [glob -nocomplain "*.tmp"]
  foreach file $files {catch {file delete -force -- $file}}
##################
 set grab [ncgetl $defskin]
 if {$grab != ""} {

  foreach line $grab {
    switch [lindex $line 0] {
      \#!REV {set reve [lindex $line 1]}
      NEW {set NEW(default) [lindex $line 1]}
      DUPE {set DUPE(default) [lindex $line 1]}
      NEWDATE {set DATE(default) [lindex $line 1]}
      DEL {set DEL(default) [lindex $line 1]}
      DEL-AUTO {set DELA(default) [lindex $line 1]}
      PRE {set PRE(default) [lindex $line 1]}
      INCOMPLETE {set INCD(default) [lindex $line 1]}
      NUKE {set NUKE(default) [lindex $line 1]}
      NUKE-STAT {set NUKS(default) [lindex $line 1]}
      UNNUKE {set UNNK(default) [lindex $line 1]}
      RACER {set RACE(default) [lindex $line 1]}
      HALFWAY {set HALF(default) [lindex $line 1]}
      COMPLETE {set COMP(default) [lindex $line 1]}
      COMPLETE-MP3 {set CID3(default) [lindex $line 1]}
      UPDATE {set SFV(default) [lindex $line 1]}
      BANDWIDTH {set MISC(BW) [lindex $line 1]}
      INVITE {set MISC(INV) [lindex $line 1]}
      USERSTAT {set MISC(UST) [lindex $line 1]}
      GROUPSTAT {set MISC(GST) [lindex $line 1]}
      RACESTAT {set MISC(TST) [lindex $line 1]}
      HEADER {set MISC(HED) [lindex $line 1]}
    }
  }
    if ![string match $reve "B"] {die "sitestat: CRITICAL : $defskin isn't a compatible skin version"}
  } else {
    die "sitestat: CRITICAL : missing or invalid default announce skin file $defskin"
  }
  foreach areaname $arealist {
    set dexemptions($areaname) ""
    set nukerules($areaname) ""
    if {![info exists fbdeletes($areaname)]} {set fbdeletes($areaname) ""}
    if {![info exists nbdeletes($areaname)]} {set nbdeletes($areaname) ""}
    if {![info exists fbprocess($areaname)]} {set fbprocess($areaname) ""}
    set grab [ncgetl $areaname$skincfg]
    if {$grab != ""} {
      foreach line $grab {
        switch [lindex $line 0] {
        NEW {set NEW($areaname) [lindex $line 1]}
        DUPE {set DUPE($areaname) [lindex $line 1]}
        NEWDATE {set DATE($areaname) [lindex $line 1]}
        DEL {set DEL($areaname) [lindex $line 1]}
        DEL-AUTO {set DELA($areaname) [lindex $line 1]}
        PRE {set PRE($areaname) [lindex $line 1]}
        NUKE {set NUKE($areaname) [lindex $line 1]}
        NUKE-STAT {set NUKS($areaname) [lindex $line 1]}
        UNNUKE {set UNNK($areaname) [lindex $line 1]}
        RACER {set RACE($areaname) [lindex $line 1]}
        HALFWAY {set HALF($areaname) [lindex $line 1]}
        INCOMPLETE {set INCD($areaname) [lindex $line 1]}
        COMPLETE {set COMP($areaname) [lindex $line 1]}
        COMPLETE-MP3 {set CID3($areaname) [lindex $line 1]}
        UPDATE {set SFV($areaname) [lindex $line 1]}
      }
    }
  }

  set grab [ncgetl $areaname$dupecfg]
  if {$grab != ""} {
    foreach curline $grab {
      set curline [string trim $curline]
      if {[string index [lindex $curline 0] 0] == "#" || $curline == ""} {continue}
      lappend dexemptions($areaname) [string tolower $curline]
    }
  }
  set grab [ncgetl $areaname$nukecfg]
  if {$grab != ""} {
    foreach curline $grab {
      set curline [string trim $curline]
      if {[string index [lindex $curline 0] 0] == "#" || $curline == ""} {continue}
      lappend nukerules($areaname) [string tolower $curline]
    }
  }
  if {![file readable $areaname$uploadsdb]} { 
    catch {open $areaname$uploadsdb w} f1
    if {$f1 != 1} {
      flush $f1 ; close $f1
      putlog "sitestat: created $areaname uploads database"
    } else {
      putlog "sitestat: ERROR : could not create $areaname uploads database"
    }
  } else {
    putlog "sitestat: $areaname uploads database found" 
  }
  if {![file readable $areaname$nukesdb]} { 
    catch {open $areaname$nukesdb w} f1
    if {$f1 != 1} {
      flush $f1 ; close $f1
      putlog "sitestat: created $areaname nukes database"
    } else {
      putlog "sitestat: ERROR : could not create $areaname nukes database"
    }
  } else {
      putlog "sitestat: $areaname nukes database found" 
  }

 }
}

proc fixstr {str} {
  set remap ". {\?} { } {\?} _ {\?} , {\?}"
  set clean [string map -nocase $remap $str]
  return $clean
}

proc skipcheck {area dir} {
  variable dexemptions
  set dirlen [string length $dir]
  foreach curline $dexemptions($area) {
    set rv 0
    set qw [lindex $curline 0]
    if {$qw != "w:0"} {continue}
    set qc [lindex $curline 1]
    set reas [lindex $curline 2]
    set args [lrange $curline 3 end]
    foreach arg $args {
      set arg [split $arg ":"]
      incr rv [argchk [lindex $arg 0] [lindex $arg 1] $dir $dirlen]
    }
    if {$qc == $rv} {putlog "> exempt - $reas" ; return 1} 
  }
  return 0
}

proc argchk {argt arg dir dirlen} {
  set dir [string tolower $dir]
  switch $argt {
    a {if [string match "*$arg*" $dir] {return 1}}
    b {if ![string match "*$arg*" $dir] {return 1}}
    c {if [string match "$arg*" $dir] {return 1}}
    d {if ![string match "$arg*" $dir] {return 1}}
    e {if {$arg > $dirlen} {return 1}}
    f {if {$arg < $dirlen} {return 1}}
    g {if {$arg == $dir} {return 1}}
    h {if {$arg != $dir} {return 1}}
  }
  return 0
}

proc nukecheck {area dir} {
  variable nukerules
  upvar #0 nukecheck uautonuke
  if {$uautonuke == 0} {return "GOOD"}
  putlog "sitestat: nukechecking..."
  set reason "GOOD" 
  set dirlen [string length $dir]
  foreach curline $nukerules($area) {
    set qw [lindex $curline 0]
    set qc [lindex $curline 1]
    set reas [lindex $curline 2]
    set args [lrange $curline 3 end]
    set rv 0
    foreach arg $args {
      set arg [split $arg ":"]
      incr rv [argchk [lindex $arg 0] [lindex $arg 1] $dir $dirlen]
    }
    switch $qw {
      w:0 { if {$qc == $rv} {putlog "> exempt - $reas" ; break} }
      w:1 { if {$qc == $rv} {set reason $reas ; putlog "> failed - $reas" ; break} }
    }
  }   
  return $reason
}

proc GETX {area dir} {
  variable uploadsdb
  variable fbprocess
  variable fbdeletes
  set retvalue ""
  putlog "sitestat: checking owner..."
  set fbp [array names fbprocess $area]
  if {$fbp != ""} {
    foreach curline $fbp {
      set cdir [lindex $curline 1]
      if [string equal $dir $cdir] {set retvalue $curline}
    }
  }
  if {$retvalue != ""} {return $retvalue}
  if [file readable $area$uploadsdb] { 
    set f1 [open $area$uploadsdb r]
    while {![eof $f1]} {
      set curline [gets $f1]
      if {$curline == ""} {continue}
      set cdir [lindex $curline 1]
      if [string equal $dir $cdir] {set retvalue $curline}
    }
    close $f1
  }
  if {$retvalue == ""} {return "GOOD"}
  return $retvalue
}

proc GET {area dir {mode 0}} {
  if {$mode == 1} {return [GET1 $area $dir]}
  if {$mode == 2} {return [GETX $area $dir]}
  variable uploadsdb
  variable fbprocess
  variable fbdeletes
  putlog "sitestat: dupechecking..."
  set name "$area$uploadsdb" ; set retvalue ""
  if [skipcheck $area $dir] {return "GOOD"}
  set dir [string tolower [fixstr $dir]]
  set fbp [array get fbprocess $area]
  if {$fbp != ""} {
    foreach item $fbp {
      if {$item == ""} {continue}
      set cdir [file tail [lindex $item 1]]
      if [string match $dir [string tolower $cdir]] {
        set fbd [array names fbdeletes $area]
        if {$fbd != "" && [lsearch [lindex $fbd 1] $cdir] != -1} {continue}
        putlog "> failed" 
        return "\002[lindex $item 2]\002 on \002[clock format [lindex $item 0] -format "%m/%d/%y"]\002 ([lindex $item 1])"
      }
    }
  }
  if {[file readable $name]} { 
    set f1 [open $name r]
    while {![eof $f1]} {
      set item [gets $f1]
      if {$item == ""} {continue}
      set cdir [file tail [lindex $item 1]]
      if [string match $dir [string tolower $cdir]] {
        set fbd [array names fbdeletes $area]
        if {$fbd != "" && [lsearch [lindex $fbd 1] $cdir] != -1} {continue}
        putlog "> failed" 
        set retvalue "\002[lindex $item 2]\002 on \002[clock format [lindex $item 0] -format "%m/%d/%y"]\002 ([lindex $item 1])"
        break
      }
    }
    close $f1
  }
  if {$retvalue == ""} {return "GOOD"}
  return $retvalue
}

proc GET1 {area dir} {
  variable uploadsdb
  variable fbprocess
  set name "$area$uploadsdb"
  putlog "> searching... $name"
  set retvalue ""
  set fbp [array get fbprocess $area]
  if {$fbp != ""} {
    foreach item $fbp {
      if {$item == ""} {continue}
      set cdir [file tail [lindex $item 1]]
      if [string match $dir [string tolower $cdir]] {
        set retvalue [linsert $retvalue 0 $item]
      }
    }
  }
  if [file readable $name] { 
    set f1 [open $name r]
    while {![eof $f1]} {
      set item [gets $f1]
      if {$item == ""} {continue}
      set cdir [file tail [lindex $item 1]]
      if [string match $dir [string tolower $cdir]] {
        set retvalue [linsert $retvalue 0 $item]
      }
    }
    close $f1
  }
  if {$retvalue == ""} {return "GOOD"}
  return $retvalue
}



proc ADD {area dir mode user timestamp} {
  variable fbprocess
  if {[lsearch [array names fbprocess] $area] == -1} {set fbp ""} else {set fbp $fbprocess($area)}
  append fbp " \{$timestamp \{$dir\} $user $mode\}"
  set fbprocess($area) $fbp
}

proc DEL {area dir} {
  variable fbprocess
  variable fbdeletes
  if {[lsearch [array names fbprocess] $area] != -1} {
    set fbp $fbprocess($area)
    set x 0
    foreach item $fbp {
      if {$item==""} {continue}
      set cdir [lindex $item 1]
      if {[string equal $cdir $dir]} {set fbprocess($area) [lreplace $fbp $x $x] ; break }
      incr x
    }
  }
  if {![regexp $area [array names fbdeletes]]} {
    set fbdeletes($area) $dir
  } else {
    lappend fbdeletes($area) $dir
  }
}


proc FLUSH {{cmd ""}} {
  variable fbprocess
  variable fbdeletes
  variable uploadsdb
  set fbn [array names fbprocess]
  if {$fbn=="ss:x4"} {return 0}
  set nowtime [clock seconds]
  set areatmp "" ; set f1 "" ; set f2 ""
  putlog "sitestat: checking uploads database buffer..."
  foreach item $fbn {
    if {$item=="ss:x4" || $item==""} {continue}
    set afb $fbprocess($item)
    if {$afb==""} {continue}
    catch {open $item$uploadsdb a+} f1
    if {$f1 == 1} {putlog "sitestat: CRITICAL : unable to flush uploads database" ;  return 1}
    set fob 0 ; set fab ""
    foreach fentry $afb {
      set utime [lindex $fentry 0]
      if {$utime == ""} {set fab "" ; incr fob ; break}
      if {$cmd != "force" && [expr $nowtime - $utime] < 600} {set fab [lrange $afb $fob end] ; break}
      putlog ">> ($item) $fentry"
      puts $f1 "$fentry"
      incr fob
    }
    if {$fob > 0} {set fbprocess($item) $fab}
    close $f1
  }
  putlog "sitestat: flush complete"
}


proc CLEAN {{cmd ""}} {
  variable uploadsdb
  variable nukesdb
  upvar #0 udb_age agelimit
  variable nbdeletes 
  variable fbdeletes 
  upvar #0 arealist arealist
  variable cac
  set bnum 0
  if {$agelimit != 0} {set trange [expr [clock seconds] - [expr $agelimit * 86400]]} else {set trange 86400}
  if {$cmd == "force"} {
    set areanames $arealist
  } else {
    set areanames [lindex $arealist $cac]
  }

  foreach areaname $areanames {
  putlog "sitestat: ($areaname) database cleaning in progress..."

###################### UPLOADS DATABASE.
  set ubd [array names fbdeletes]
  if {[lsearch $ubd $areaname] != -1 && $fbdeletes($areaname) != ""} {
    set go 1
  } else {
    set go 0
  }
  if {$go} {
    set f1 [open $areaname$uploadsdb r]
    set tmp $areaname ; append tmp "base.tmp"
    catch {open $tmp w} f2
    if {$f2 == 1} {
      close $f1
      putlog "sitestat: ERROR : database cleaner could not create temp file"
      return
    }
    while {![eof $f1]} {
      set curline [gets $f1]
      if {$curline == ""} {break}
      set tdate [lindex $curline 0]
      set dpath [lindex $curline 2]
      if {[lsearch $fbdeletes($areaname) $dpath] == -1 && $tdate >= $trange} {
        puts $f2 "$curline"
      } else {
putlog "<< ($areaname) $curline"
        incr bnum
      }
    }
    close $f1
    flush $f2 ; close $f2
    if {$bnum != 0} {
      file delete -force $areaname$uploadsdb
      file rename $tmp $areaname$uploadsdb
      putlog "sitestat: ($areaname) uploads cleaned - $bnum entries removed"
    } else {
      file delete -force $tmp
    }
    set fbdeletes($areaname) ""
  }

###################### NUKES DATABASE.
  set nbd [array names nbdeletes]
  if {[lsearch $nbd $areaname] != -1 && $nbdeletes($areaname) != ""} {
    set go 1
  } else {
    set go 0
  }
  if {$go} {
    set bnum 0 ; set go 0
    set f1 [open $areaname$nukesdb r]
    set tmp $areaname ; append tmp "nuke.tmp"
    catch {open $tmp w} f2
    if {$f2 == 1} {
      close $f1
      putlog "sitestat: ERROR : database cleaner could not create temp file"
      return
    }
    while {![eof $f1]} {
      set curline [gets $f1]
      if {$curline == ""} {continue}
      set tdate [lindex $curline 0]
      set dpath [lindex $curline 1]
##########if {[string first "/" $dpath] != -1} {set path [string range $dpath [string first "/" $dpath] end]} else {set path $dpath}
########### for future use ######## if {$tdate < $trange} {set go 0} else {set go 1}
      if {[lsearch $nbdeletes($areaname) $dpath] == -1 && $tdate >= $trange} {
        puts $f2 "$curline"
      } else {
putlog "<< ($areaname) $curline"
        incr bnum
      }  
    }
    close $f1
    flush $f2 ; close $f2
    if {$bnum != 0} {
      file delete -force $areaname$nukesdb
      file rename $tmp $areaname$nukesdb
      putlog "sitestat: ($areaname) nukes cleaned - $bnum entries removed"
    } else {
      file delete -force $tmp
    }
    set nbdeletes($areaname) ""
  }
  }
  incr cac
  if {$cac >= [llength $arealist]} {set cac 0}
}

proc NDEL {area dir} {
  variable nbdeletes
  if {[regexp $area [array names nbdeletes]]} {
    set unuk $nbdeletes($area)
    append unuk " \{$dir\}"
  } else {
    set nbdeletes($area) "\{$dir\}"
  }
}

proc NGET {area dir} {
  variable nukesdb
  variable nbdeletes 
  variable cac
  set ndb $area$nukesdb
#  if {[skipcheck $area $dir]} {return "GOOD"}
  set dir [string tolower [fixstr $dir]]
  set retvalue "GOOD"
  if [file readable $ndb] {
    set f1 [open $ndb r]
    while {![eof $f1]} {
      set curline [string trim [gets $f1]]
      if {$curline == ""} {continue}
      set cdir [lindex $curline 1]
      if {[string match $cdir $dir]} {
        set retvalue "NUKED on \002[clock format [lindex $curline 0] -format "%m%d"]\002 by \002[lindex $curline 2]\002"
        break
      }
    }
    close $f1
    return $retvalue
  }
}


proc NGETX {area dir nuker} {
  variable nukesdb
  set ndb $area$nukesdb
  set dir [string tolower $dir]
  set retvalue "GOOD"
  if [file readable $ndb] { 
    set f1 [open $ndb r]
    while {![eof $f1]} {
      set curline [string trim [gets $f1]]
      if {$curline == ""} {continue}
      set cdir [lindex $curline 1]
      set pos [string last / $cdir]
      if {$pos != -1} {set cdir [string range $cdir [expr $pos + 1] end]}
      if {$nuker == [lindex $curline 4] && $cdir == $dir} {
        set retvalue "[lrange $curline 2 3] [lindex $curline 5]"
        break
      }
    }
    close $f1
    return $retvalue
  }
}



proc NADD {area dir nuker reason other fowner} {
  variable nukesdb
  variable cac
  set ndb $area$nukesdb
  set nowtime [clock seconds]
  if {[skipcheck $area $dir] || [lindex $reason 0] == "0x" || [lindex [string toupper $reason] 1] == "EMPTY"} {return}
  catch {open $ndb a+} f1
  if {$f1 != 1} { 
    puts $f1 "$nowtime \{[string tolower $dir]\} $nuker \{$reason\} $fowner \{$other\}"
    close $f1
    putlog "sitestat: nuke info recorded"
  } else {
    putlog "sitestat: CRITICAL : could not write to file $ndb"
  }
}

################################ getl with case agnostic support
proc regcase {infile} {
 set filename ""
 foreach inl [split [string tolower $infile] {}] {
   set ind ""
   regexp {[a-z]} $inl ind
   if {$ind != ""} {
     set ind [string toupper $ind]
     append filename "\[$ind$inl\]"
   } else {
     append filename $inl
   }
 }
 return $filename
}
proc ncgetl {infile} {
 set of 1 ; set llist ""
 set cfile [glob -nocomplain -- $infile]
 if {$cfile != $infile} {
   set filename [regcase $infile]
   set cfile [glob -nocomplain -- *]
   foreach file $cfile {
     if {![string match $filename $file]} {continue}
     set infile $file ; break
   }
 }
 set llist [getl $infile]
 return $llist
}
###############################


proc getl {filename} {
  set of 1 ; set llist ""
  set cfile [glob -nocomplain -- $filename]
  if {$cfile != $filename} {return ""}
  catch {open $filename r} of
  if {$of != 1} {
    set size [file size $filename]
    if {$size != 0} {set llist [read $of $size]}
    close $of
    return [split $llist \n]
  }
  return ""
}

#################################################### end code.
}