set ssver "Sitestat 5.0 RC2 for glftpd by GOD-EMPEROR (2002)"
#
# Need HELP/UPDATES join #imperium (EFnet) 
# Bug Reports, Suggestions and Comments are welcome
#
# Note: This tcl is for use with any Eggdrop with TCL 8.3 or higher
#    (if your bot won't load it there could be many reasons, try a dif version)
#    -- Tested with Eggdrop 1.6 and later both Cygwin & *nix versions --
#
#
###########################################################
# Skinning allows you to define announce styles seperately for each area,
# like the dupecheck and nukecheck .cfg files you also name them according
# to the area, <areaname>_skin.cfg .... however you also have to choose an
# existing skin as a default, you can then override that default as-needed..
set defskin "tj_skin.cfg"

######## Sitestat's FTP login #########################
##
##   sitebot's flags MUST be "14ABCDEFGHI"
##   sitebot's group MUST be "SITEBOT" 
##
##   DON'T PUT AN EXCLAMATION IN FRONT OF THE LOGIN NAME!!!
##
set site(name) "SITE"
set site(ip) "192.168.0.1"
set site(port) "21"
set site(login) "sitebot"
set site(pass) "sitestat"

######### Miscellaneous ########################
##
set showlast 15		;# number of last uploads/dupes/nukes to display
set anti_idle 0		;# minute interval for anti idle protection cycle (0=off)
set idlelimit 120	;# idle minutes a partyline user stays authorized after .login
set allowrules 1	;# allow !siterules command to list site rules on IRC
set userkill 1		;# delete users that failed trial

set defgrp "NoGroup"	;# default group to show for ungrouped users
set igroups "STAFF"	;# groups to ignore from announcing certain activity

set deftag "..I suck long and hard"	;# default tagline

set lowspacewarn 00	;# minimum free diskspace (MB) to consider LOW
set totalspace 20000	;# diskspace (GB) to show as total in '!sitefree all'

######## SERVER PRE-CONFIG SECTION #############
##
##  IMPORTANT: read the comments, don't assume you know everything
##
set cmdpre "!site"	;# command prefix - including special character
set nfocmd "!nfo"	;# the command to get the site nfo (requires transfer module)
set fnfo "blah.nfo"	;# your site .nfo file, must be located in the egg dir

############### Special Channels ###############
##
##  set to "all" for all channels, set blank to disable
##  note: channels must be lowercase!
##----------------------------------------------
##  announce logins/logouts/bncs/trials here 
##
set site(spchans) "#imperium #itr"
##
##  enable/disable announcing these, also note:
##  - bnc command will be off if no bncs set in ss-local
##  - every group in $igroups will not trigger login/logout
##
set showtrials 1	;# announce trials, allow !sitetrials
set showlogins 1	;# announce login/logout
set showbncs 1		;# allow !sitebnc

################################################
##
##  'home' channel for /msg invite, and for the command scheduler target 'home'
##  (set blank to disable)
##
set site(home) "#imperium"
##
##  set which multicast bots are allowed to invite, "" for none, "all" for all
##
set site(remote) ""

######### AutoNuker settings ###################
##
##  feature toggles (0=off/1=on)
##
set nukecheck 1        ;# Enable nukechecking of uploads
set nuke(renuke) 1     ;# Nuke previously nuked dupes
set nuke(dupe) 0       ;# Nuke duplicate dirs 
set nuke(warn) 0       ;# AutoNuker should only warn and not nuke
set nuke(mult) 1       ;# AutoNuke default nuke multiplier
set nuke(del) 1        ;# AutoDelete instead of AutoNuke dirs 
##
##  AutoDelete reason when cleaning areas to quota
##
set quotamsg "EXCEEDED QUOTA"

######### Post-Complete Race command ###########
##
##  This commandline will be executed on the ftp upon a race being
##  completed, it can be any command such as "dele ds.nfo" or calling 
##  a custom site script like "site mylamecmd"
##
##  valid remappables are: 
##   %dir% - the dir name without path eg. 'foobar-rls'
##   %path% - the path leading up to the dir eg. '/incoming/m00/'
##   %date% - the current date as MM.DD.YY eg. 07.07.02
##
##  note: completecmd's are executed from within the completed dir itself,
##    so if a command such as chmod or rename is to be called upon the dir
##    then 'CWD ..' will have to be called before it
##
set completecmd1 ""
set completecmd2 ""
set completecmd3 ""

################# BOT SETTINGS #################
##
##  IMPORTANT: remember to edit ss5.cfg !!
##
##  announce messages - 0=off/1=on
##
set bot(hidden) 1	;# enable to ignore public commands from non-announce channels
set sonjoin 0		;# show site info onjoin --- anyone with +o flag will not see it
set ownerjoin 1		;# show onjoin for bot owners

################################################
##
##  default settings for public channel commands (read help on !siteset)
##
set pubcmd "on"  ;# all channel commands except help
set pubwho "on"  ;# the !sitewho command

############ Uploads/Nukes database settings #########
##
##  set however many days you want Sitestat to remember new & nuked dirs
##
set udb_age 45

########### SITE WHO Parsing switches ##########
##
##  if the 'site who' has been replaced by a script in glftpd
##  then compile and install the sswho util, and set the below
##  accordingly; also its necessary to adjust how many lines of
##  header and footer to strip for the internal who
##
##  mode: 1 = normal, 2 = sswho
##  cmd: the command to call who, 'site ????' eg. 'who' or 'sswho'
##  
set who(mode) 2
set who(cmd) "sswho"

##  adjust for the header and footers in the site who..
##  (applies to mode 1 only)
##
##  regular unmodified who has 4 lines on top and 6 on bottom to chop off
set who(off_top) 4
set who(off_bot) 6

########### Nothing need to be modified beyond this point #############

############################################################
# these are the ctrl codes for easier scripting eg: [u] for underline
proc u {} {return };	# underline code
proc r {} {return };	# reverse code
proc b {} {return };	# bold code
proc c {} {return };	# color code
proc o {} {return };	# reset attributes code
##########################################################
# command bindings, eg. !sitelast or !sitebw
bind pub - $nfocmd dccnfo
bind pub - [set cmdpre]bnc showbnc
bind pub - [set cmdpre]incs showinc
bind pub - [set cmdpre]trials showtr
bind pub - [set cmdpre]passed passalias
bind chat - "[set cmdpre]help *" userhelp2
bind chat - "[set cmdpre]help2 *" morehelp2
bind chat - [set cmdpre]help userhelp2
bind chat - [set cmdpre]help2 morehelp2
bind pub - [set cmdpre]help userhelp
bind pub - [set cmdpre]help2 morehelp
bind pub o [set cmdpre]msg announcement
bind pub - [set cmdpre]rules rulesalias
bind chat - "[set cmdpre]search *" sitesearch2
bind chat - "[set cmdpre]stat *" sitestat2
bind chat - [set cmdpre]stat sitestat2
bind chat - "[set cmdpre]last *" sitelast2
bind chat - "[set cmdpre]dir *" sitedir2
bind pub - [set cmdpre]search sitesearch
bind pub - [set cmdpre]stat sitestat
bind pub - [set cmdpre]last sitelast
bind pub - [set cmdpre]dir sitedir
bind pub m [set cmdpre]set siteset
bind pub - [set cmdpre]ver sitever
bind pub - [set cmdpre]build sitever2
bind chat - "[set cmdpre]incs *" showinc2
bind chat - [set cmdpre]incs showinc2
bind chat - "[set cmdpre]passed *" passalias2
bind chat - [set cmdpre]passed passalias2
bind chat - "[set cmdpre]trials *" showtr2
bind chat - [set cmdpre]trials showtr2
bind chat - "[set cmdpre]bnc *" showbnc2
bind chat - [set cmdpre]bnc showbnc2
bind chat - "[set cmdpre]idlers *" idlealias2
bind chat - [set cmdpre]idlers idlealias2
bind chat - "[set cmdpre]uploaders *" upalias2
bind chat - [set cmdpre]uploaders upalias2
bind chat - "[set cmdpre]leechers *" leechalias2
bind chat - [set cmdpre]leechers leechalias2
bind chat - "[set cmdpre]speed *" speedalias2
bind chat - "[set cmdpre]free *" freealias2
bind chat - "[set cmdpre]user *" useralias2
bind chat - "[set cmdpre]who *" whoalias2
bind chat - [set cmdpre]who whoalias2
bind chat - "[set cmdpre]bw *" bwalias2
bind chat - [set cmdpre]bw bwalias2
bind pub - [set cmdpre]uploaders upalias
bind pub - [set cmdpre]leechers leechalias
bind pub - [set cmdpre]idlers idlealias
bind pub - [set cmdpre]speed speedalias
bind pub - [set cmdpre]free freealias
bind pub - [set cmdpre]user useralias
bind pub - [set cmdpre]who whoalias
bind pub - [set cmdpre]bw bwalias
bind pub m [set cmdpre]add addftpuser
##
###### msg command bindings
##
bind msg - !inv msginvite
bind msg - !kill msgghost
bind msg - !nuke msgnuke
##
###### internal functions
##
bind dcc - logout dcckillauth
bind dcc - login dccauthlog
bind dcc m relog dccftplogon
bind dcc m recfg reconfig
bind dcc m cleanup tieup
bind dcc - site sitecmdhandler
bind dcc m newdate datewrapper
bind dcc - dccwho listlogged
bind dcc - showmsg sda
bind dcc m ssdbg ddump
bind dcc m setskin setskin
bind chof - * killauth
bind join - * siteonjoin
##
########### commonized
##
bind pub - !ssver sitever
bind pub - !ssbuild sitever2
bind chat - !ssver dccsitever
bind chat - !ssbuild dccsitever2
##
unbind dcc m restart *dcc:restart
bind dcc m restart ssrestart
#### internal variables and stuff, do not modify! ####
set nbclean 1
set status 1
set cmode 0
set lastoct 1
set ueprocess 0
set ulprocess 0
set fbinuse 1
set idlestamp 1
set noopcnt 0
set stasks(spk) ""
set dtasks(ss:x5) ""
set build 5.0.065
set laststamp 0:00
set incs(ss:x5) "dummy"
set dccauth(ss:x5) "dummy"
set m3n(ss:x5) "dummy"
set ftpbuf(ss:x5) "dummy"
set nukebuf(ss:x5) "dummy"
set symlinks(ss:x5) "dummy"
set dccauth(ss:x5) "dummy"
set nbdeletes(ss:x5) "dummy"
if {![info exists bncknt]} {set bncknt 0}
if {![info exists bnclist]} {set bnclist ""}
if {![info exists sdaidxlist]} {set sdaidxlist ""}
if {![info exists ftpflag]} {set ftpflag ""}
if {![info exists sscact]} {set sscact 9}
set remap "{\[} {} {\]} {} ( {} ) {} M/ \002MB/\002 F/ \002F/\002 %/ \002%@\002 K \002K"
set site(nuking) 0 ;# allow MSG nuking using ftp login info?
######################################################### begin code.
## TCL autoloader
if {![info exists FLVER] && [glob -nocomplain "ss-ftplib.tcl"] != ""} {
 source ss-ftplib.tcl
}
if {![info exists FBEVER] && [glob -nocomplain "ss-fbelib.tcl"] != ""} {
 source ss-fbelib.tcl
}
if {[set tcl_version] < 8.3} {die "sitestat: CRITICAL : incompatible TCL version found (8.3 or later required)"}

proc getwho {} {
  global who
  set ee [FTP::Quote site $who(cmd)]
  if {$ee == ""} {return ""}
  set reply ""
  if {$who(mode) == 1} {
    set lines [lrange [split $ee \n] $who(off_top) end-$who(off_bot)]
    foreach line $lines {
	if {[string index $line 0] == "-"} {continue}
	set line [string range $line 6 end-1]
	foreach {name group tagline action} [split $line "|"] {}
	if {$action == ""} {break}
	set name [string trim $name]
	set group [string trim $group]
	set speed [lindex $action end]
	switch -- [lindex $action 0] {
		UL: {set statu "upld" ; set speed [string range $speed 0 end-3] ; set action [lindex $action 1]}
		DL: {set statu "dnld" ; set speed [string range $speed 0 end-3] ; set action [lindex $action 1]}
		IDLE {set statu "idle" ; set action [lrange $action 1 end] ; set speed 0}
		default {set statu "idle" ; set action "fucking the dog" ; set speed 0}
	}
	lappend reply $name
	lappend reply $group
	lappend reply $tagline
	lappend reply $statu
 	lappend reply $speed
 	lappend reply $action
    }
  } elseif {$who(mode) == 2} {
    foreach line [lreplace [split $ee \n] end end] {
	set statu "gob"
	foreach {name group tagline statu speed activity} [split [string range $line 5 end] "|"] {}
	if {$statu == "gob"} {break}
	lappend reply $name
	lappend reply $group
	lappend reply $tagline
	lappend reply $statu
	switch -- $statu {
		upld {}
		dnld {} 
		idle {
			foreach {hm mm sm} [split $speed ":"] {}
			if {[string index $mm 0] == 0} {set mm [string index $mm 1]}
			if {[string index $sm 0] == 0} {set sm [string index $sm 1]}
			set activity "for [set mm]m [set sm]s"
			set speed 0
		}
	}
	lappend reply $speed
	lappend reply $activity
    }
  }
  return $reply
}


proc reconfig {hand idx args} {
 global allchans bot arealist aflags ssxlist ssxconn stasks site dtasks defskin MISC ftpt
 set allchans "" ; set cmode 19
 set b_a "" ; set a_a "" ; set arealist ""
 set aflags(ss:x5) ""
 array unset stasks
 array unset dtasks
 set stasks(spk) ""
 set seymore 1
 set ssxlist "" ; set ssxconn ""
 set scfg [fbe::getl ss5.cfg]
 if {$scfg != ""} {
   foreach curline $scfg {
     set curline [string trim $curline]
     if {[string index $curline 0] == "#" || $curline == ""} {continue}
     if {$curline == "\[ANNOUNCE\]"} {set cmode 0 ; continue
     } elseif {$curline == "\[MULTICAST\]"} {set cmode 1 ; continue
     } elseif {$curline == "\[SCHEDULE\]"} {set cmode 2 ; continue
     } elseif {$curline == "\[AREALIMITS\]"} {set cmode 3 ; continue
     } elseif [string match "\[*" $curline] {set cmode 19 ; continue}
     switch $cmode {
	0 {
		if {[string index $curline 0] == "/"} {
			set path [lindex $curline 0] ; set areaname [lindex $curline 1] ; set chans [tlow [lindex $curline 2]] ; set taflag [tlow [lindex $curline 3]]
			if {$areaname == "" || $chans == ""} {continue}
			set sect 0 ; set aflag ""

			if {[string first "s" $taflag] != -1} {append aflag "s"}
			if {[string first "d" $taflag] != -1} {append aflag "d"}
			if {[string first "u" $taflag] != -1} {append aflag "u"}
			if {[string first "n" $taflag] != -1} {append aflag "n"} 
			if {[string first "h" $taflag] != -1} {append aflag "h"}
			if {[string first "c" $taflag] != -1} {append aflag "c"}
			if {[string first "g" $taflag] != -1} {append aflag "g"}
			if {[string first "i" $taflag] != -1} {append aflag "i"}
			regexp \[0-9\] [list $taflag] sect ; append aflag $sect
			if {$aflag != ""} {append aflag "x"}
			set aflags($areaname) $aflag
			append a_a "$path $areaname \{$chans\} "
			append arealist "$areaname "
			set ftpt($areaname) 0
			foreach chan $chans {if {[lsearch $allchans $chan] == -1} {append allchans " $chan"}}
		}
	  }
	1 {
		if {[llength $curline] != 2} {continue}
		if {$ssxlist != ""} {append ssxlist " "} 
		append ssxlist "[lindex $curline 0] [lindex $curline 1]"
	  }
	2 {
		set cmd [tlow [lindex $curline 0]]
		set el [llength $stasks(spk)]
		set dest [tlow [lindex $curline 1]]
		set ts [lindex $curline 2]
		if {$ts == ""} {continue}
		if {$dest == "home"} {
			set chans $site(home)
		} elseif {$dest == "special"} {
			set chans $site(spchans)
		} else {
			set pos [lsearch $a_a $dest]
			if {$pos == -1} {continue} ; incr pos
			set chans [lindex $a_a $pos]
		}
		if {$chans == ""} {continue}
		switch -- $cmd {
			bw {set cmd "bw123"}
			who {set cmd "who123"}
			uploaders {set cmd "\{usage up\}"}
			leechers {set cmd "\{usage le\}"}
			idlers {set cmd "\{usage id\}"}
			default {
				set poo [lsearch "dayup daydn mnup mndn monthup monthdn gpwk gpwd gpal gpad wkup wkdn alup aldn" $cmd]
				if {$poo == -1} {continue}
			}
		}
		set stasks($el) "\{$chans\} $cmd"
		append stasks(spk) "$el $ts "
	  }
	3 {
		if {[llength $curline] != 3} {continue}
		set dtasks([lindex $curline 0]) "\{[lindex $curline 1]\} \{[lindex $curline 2]\}"
	  }
     }
   }
   if {$a_a != ""} {set bot(announce) $a_a}
 } else {
   die "sitestat: CRITICAL : ss4.cfg is missing, or not readable"
 }
 fbe::INIT $defskin
 set botl [bots]
 set skinmap "\[b\] [b] \[u\] [b] \[c\] [b] \[r\] [r] \[o\] \{\015\} %site% \{$site(name)\}"
 set MISC(HED) [string map $skinmap $MISC(HED)]
 set ssxconn ""
 foreach {sbot sflg} $ssxlist {
	if {$sbot == ""} {break}
	if {[lsearch $botl $sbot] != -1} {append ssxconn "$sbot $sflg "}
 }

 putlog "sitestat: supported channels -$allchans"
}

proc shuffle5 {list} {
    set n 1
    set slist ""
    foreach item $list {
      set index [expr {int(rand()*$n)}]
      set slist [linsert $slist $index $item]
      incr n
    }
    return $slist
}

proc dccnfo {nick uhost hand chan args} {global idlestamp fnfo ; dccsend $fnfo $nick}
proc gettime {{t ""}} {
	if {$t == ""} {set t [clock seconds]}
	return [clock format $t -format "%Y/%m/%d"]
}
proc gedate {{t ""}} {
	if {$t == ""} {set t [clock seconds]}
	return [clock format $t -format "%m%d"]
}

proc tlow {txt} {return [string tolower $txt]}
proc tup {txt} {return [string toupper $txt]}
proc mavg {nums} {
	set retval 0
	set retl [llength $nums]
	if {$retl == 0} {return 0}
	foreach num $nums {incr retval $num}
	if {$retval != 0} {set retval [expr $retval / $retl]}
	return $retval
}

proc madd {nums} {
	set retval 0
	foreach num [concat $nums] {incr retval $num}
	return $retval
}

proc mexp {nums} {
	set retval 1
	foreach num [concat $nums] {set retval [expr $retval * $num]}
	return $retval
}

proc rep {str cnt} {
	return [string repeat $str $cnt]
}

proc fixbr {str} {
	return [list $str]
}

proc fixstr {str} {
  set remap ". {\?} { } {\?} _ {\?} , {\?}"
  set clean [string map $remap $str]
  return $clean
}

proc rndf {num {dec 2}} {
  set pos [string first . $num]
  if {$pos != -1} {
    incr pos $dec
    set num [string range $num 0 $pos]
    incr pos
  } else {
    append num .
    set pos [string length $num]
    incr pos $dec 
  }
  set num [fixlenc $num $pos 0]
  return $num
}

proc strsort {slist {index 0}} {return [lsort -dictionary -index $index $slist]}
proc intsort {slist {index 0}} {return [lsort -decreasing -integer -index $index $slist]}
proc intsort2 {slist {index 0}} {return [lsort -increasing -integer -index $index $slist]}

proc fixsl {size {len 0}} {
  if {$size > 9999} {
    set size [rndf [expr $size / 1024] 2]
    append size "GB"
  } else {
    append size "MB"
  }
  set ll [string length $size]
  if {$ll < $len} {
	set ret [string repeat " " [expr $len - $ll]]
	return $ret$size
  } else {
	return $size
  }
}

proc fixlen {txt len} {
  set ll [string length $txt]
  if {$ll >= $len} {
	set txt [string range $txt 0 [expr $len - 1]]
  } else {
	append txt [string repeat " " [expr $len - $ll]]
  }
  return $txt
}

proc fixlenc {txt len char} {
	if {[string length $txt] >= $len} {
		set txt [string range $txt 0 [expr $len - 1]]
	} else {
		append txt [string repeat $char [expr $len - [string length $txt]]]
	}
	return $txt
}
	
proc fixlenr {txt len} {
  set pos [string length $txt]
  if {$pos < $len} {
    set txt1 [string repeat " " [expr $len - $pos]]
    append txt1 $txt
  } elseif {$pos > $len} {
    set txt1 [string range $txt [expr $pos - $len] end]
  } else {
    return $txt
  }
  return $txt1
}

proc fixsize {size} {
  if {$size >= 1073741824} {
    return "[b][rndf [expr $size / 1073741824.0] 2][b]GB"
  } elseif {$size >= 1048576} {
    return "[b][rndf [expr $size / 1048576.0] 2][b]MB"
  } elseif {$size >= 1024} {
    return "[b][rndf [expr $size / 1024.0] 2][b]KB"
  } elseif {$size > 0} {
    return "[b]1[b]KB"
  } elseif {$size <= 0} {
    return "[b]0[b]KB"
  } else {
    return "[b]empty[b]"
  } 
}

proc fixss {size} {
  if {$size >= 1048576} {
    return "[b][rndf [expr $size / 1048576.0] 2][b]GB"
  } elseif {$size >= 1024} {
    return "[b][rndf [expr $size / 1024.0] 2][b]MB"
  } else {
    return "[b][rndf $size 2][b]KB"
  } 
}

proc fixsm {size} {
  if {$size >= 1024} {
    return "[b][rndf [expr $size / 1024.0] 2][b]GB"
  } else {
    return "[b][rndf $size 2][b]MB"
  } 
}
proc fixs {size} {
  if {$size >= 1024} {
    return [expr round([expr $size / 1024.0])]
  } else {
    return "0"
  }
}

proc killtime {{sw "t"}} {
  if {$sw == "t" || $sw == "both"} {
	foreach item [timers] {killtimer [lindex $item 2]}
  }
  if {$sw == "u" || $sw == "both"} {
	foreach item [utimers] {killutimer [lindex $item 2]}
  }
}

proc loginchk {name} {
  global site
  return [string equal $name $site(login)]
}

proc doble {list1 list2} {
  foreach {arg1 arg2} $list2 {
	set pos [lsearch -exact $list1 $arg1]
	if {$pos != -1} {
		incr pos
		incr arg2 [lindex $list1 $pos]
		set list1 [lreplace $list1 [expr $pos - 1] $pos $arg1 $arg2]
	} else {
		append list1 " $arg1 $arg2"
	}
  }
  return $list1
}

proc adjcreds {user amt} {
	ftpe
	if {$amt > 0} {
		set reply [FTP::Quote SITE GIVE $user $amt]
		putlog "ftp: user credit given - $user ($amt)"
	} elseif {$amt < 0} {
		set amt [expr $amt * -1]
		set reply [FTP::Quote SITE TAKE $user $amt]
		putlog "ftp: user credit taken - $user ($amt)"
	} else {
		putlog "ftp: user credit unchanged - $user"
	}
}

proc getucreds {user} {
  ftpe
  set creds 0
  set reply [split [FTP::Quote SITE USER $user] "\n"]
  foreach line $reply {
	set part1 [string range $line 0 41]
	set line [string range $line 42 end]
	if {[lindex $part1 2] == "Ratio:" && [lindex $part1 3] == "Unlimited"} {
		set creds -1 ; break
	} elseif {[lindex $line 0] == "Credits:"} {
		set creds [lindex $line 1]
		set pos [string last "." $creds]
		if {$pos != -1} {incr pos -1 ; set creds [string range $creds 0 $pos]}
		break
	}
  }
  return $creds
}


#  mode 0 = null filecnt dirs size
#  mode 1 = (user+size) filecnt dirs size
#  mode 2 = mode 0 (and deletes files)
#  mode 3 = mode 1 (and deletes files)
#
proc ncheck {{ndir "."} {mode 0} {dirf 0} {filef 0}} {
	set dirsize 0 ; set odirs "" ; set filenames 0 ; set files ""
	ftpe
	if {$ndir != "."} {if {![FTP::Cd $ndir]} {putlog "FAILED TO CHECK - $ndir" ; return ""}}
	set lines "[FTP::List 0 .] \{\}"

	foreach line $lines {
		if {$line == ""} {continue}
		set info [string range $line 0 54]
		set name [string range $line 55 end]
		foreach {attrib blah fown group size month day stamp} $info {}

		if {$blah > 1} {
			set odirs "\{$name\} $odirs"
		} else {
			incr filenames
			if {$size > 0} {set size [expr $size / 1024] ; incr dirsize $size}

			if {$mode == 1 || $mode == 3} {
				set fown [lindex $line 2]
				set pos [lsearch $files $fown]
				incr pos
				if {$pos != 0} {
					incr size [lindex $files $pos]
					set files [lreplace $files $pos $pos $size]
				} else {
					append files " $fown $size"
				}
			} 
			if {$mode > 2} {
				FTP::Delete $name
			}
		}
	}
	return "\{$files\} $filenames \{$odirs\} $dirsize"
}


proc wanfoo {size dirsize} {
  set ret [expr {$size * 101 / $dirsize}]
  if {$ret == 101} {set ret 100}
  return $ret
}

############ Processing core

proc pressc {} {
  global idlestamp lastups lastdps lastnks sscact started rundate lastpre ftpflag
  putlog "sitestat: pressc invoked"
  if {![info exists lastups]} {set lastups ""}
  if {![info exists lastdps]} {set lastdps ""}
  if {![info exists lastnks]} {set lastnks ""}
  if {![info exists lastpre]} {set lastpre ""}
  if {![info exists ftpflag]} {set ftpflag ""}
  if {![info exists rundate]} {set rundate [gedate]}
  if {![info exists started]} {set started [gedate]}
  set sscact 0
  set lines [fbe::getl "history.ss"]
  if {$lines != ""} {
     set lastups ""
     set lastdps ""
     set lastpre ""
     set lastnks ""
     set ftpflag ""
     set rundate ""
     foreach curline $lines {
       set rid [lindex $curline 0]
       set rvalue [string range $curline 8 end]
       if {$rvalue == ""} {continue} 
       switch -- $rid {
         STARTED {set started $rvalue}
         CURDATE {set rundate $rvalue}
         LASTPRE {lappend lastpre "$rvalue"}
         LASTUPS {lappend lastups "$rvalue"}
         LASTNKS {lappend lastnks "$rvalue"}
         LASTDPS {lappend lastdps "$rvalue"}
         FTPFLAG {lappend ftpflag "$rvalue"}
       }
     }
  } else {
     ssc CLEAR
  }
}

proc ssc {reqtype {reqdata ""} {user ""} {up ""} {area ""}} {
  global idlestamp showlast lastups lastnks lastdps lastoct lastmtf rundate sscact started lastpre ftpflag
  if {$sscact == 9} {pressc}
  set reqtype [tup $reqtype]
  set retvalue ""
  set showl [expr $showlast * 2]
  set to [expr $showlast - 2]
  set curtime [gedate]
  if {$reqtype == "CURDATE"} {
    if {[tup $reqdata] == "GET"} {
       if ![info exists rundate] {set rundate $started}
       return $rundate
    }
    set rundate $reqdata
  } elseif {$reqtype == "RUNNING"} {
    if {$reqdata == "GET"} {return $started}

  } elseif {$reqtype == "CLEAR"} {
    set retvalue "done"
    set lastups ""
    set lastdps ""
    set lastpre ""
    set lastnks ""
    set ftpflag ""
    set sscact 1
    set rundate "[gedate]"
    set started "[gedate]"
    putlog "Last ups/dupes/nukes cleared"

  } elseif {$reqtype == "LASTPRE"} {
    if {$reqdata == "GET"} {return $lastpre}
    set sscact 1
    set last0 "\{$up\} $user \{$curtime\} $area"
    set lastpre [linsert $lastpre 0 "$last0"]
    if {[llength $lastpre] > $showl} {set lastpre [lrange $lastpre 0 $showl]}

  } elseif {$reqtype == "LASTUPS"} {
    if {$reqdata == "GET"} {return $lastups}
    set sscact 1
    set last0 "\{$up\} $user \{$curtime\} $area"
    set lastups [linsert $lastups 0 "$last0"]
    if {[llength $lastups] > $showl} {set lastups [lrange $lastups 0 $showl]}

  } elseif {$reqtype == "LASTDPS"} {
    if {$reqdata == "GET"} {return $lastdps}
    set sscact 1
    set last0 "\{$up\} $user \{$curtime\} $area"
    set lastdps [linsert $lastdps 0 "$last0"]
    if {[llength $lastdps] > $showl} {set lastdps [lrange $lastdps 0 $showl]}

  } elseif {$reqtype == "LASTNKS"} {
    if {$reqdata == "GET"} {return $lastnks}
    set sscact 1
    set last0 "\{$up\} $user \{$curtime\} $area"
    set lastnks [linsert $lastnks 0 "$last0"]
    if {[llength $lastnks] > $showl} {set lastnks [lrange $lastnks 0 $showl]}

  } elseif {$reqtype == "FTPFLAG"} {
###########################
#   $user == login
#   $up == handle
#   $area == showmsg flags
###########################
	set pos -1 ; set pos1 0
	foreach sda $ftpflag {
		set hand [lindex $sda 1]
		if {$hand == $up} {
			set pos 1
			set login [lindex $sda 0]
			set flags [lindex $sda 2]
			break
		}
		incr pos1
	}
	if {$reqdata == "GET"} {
		if {$pos == -1} {
			set sscact 1
			lappend ftpflag "$user $up 0"
			return "0 1"
		} else {
			if {$login == $user} {return "$flags 1"}
			return "0 0"
		}
	} elseif {$reqdata == "GETX"} {
		if {$pos == -1} {
			return 0
		} else {
			return 1
		}
	} elseif {$reqdata == "SET"} {
		set sscact 1
		if {$pos == -1} {
			lappend ftpflag "$user $up $area"
		} else {
			set ftpflag [lreplace $ftpflag $pos1 $pos1 "$user $up $area"]
		}
	}
  }
}

proc sscflush {} {
  global idlestamp showlast lastups lastnks lastdps lastoct lastmtf rundate sscact started lastpre ftpflag
  if {$sscact == 0} {return 0}
  putlog "sitestat: sscflush invoked"
  catch {open "history.ss" w} of
  if {$of != 1} { 
    puts $of "STARTED $started"
    puts $of "RUNNING [gedate]"
    if {$rundate == ""} {puts $of "CURDATE [gedate]"} else {puts $of "CURDATE $rundate"}
    
    if {$lastoct == ""} {puts $of "LASTOCT 0"} else {puts $of "LASTOCT $lastoct"}
    if {$lastups != ""} {
      foreach last $lastups {puts $of "LASTUPS $last"} 
    }
    if {$lastpre != ""} {
      foreach last $lastpre {puts $of "LASTPRE $last"}
    }
    if {$lastdps != ""} {
      foreach last $lastdps {puts $of "LASTDPS $last"}
    }
    if {$lastnks != ""} {
      foreach last $lastnks {puts $of "LASTNKS $last"}
    }
    if {$ftpflag != ""} {
      foreach last $ftpflag {puts $of "FTPFLAG $last"}
    }
    flush $of
    close $of
  } else {
    putlog "sitestat: WARNING : unable to record last uploads/dupes/nukes" 
  }
  set sscact 0
}


proc varea {{dir ""}} {
  global bot
  foreach {path aname chans} $bot(announce) {
	if [string match "$path*" $dir] {
		set pos [string length $path]
		return "$path:[string range $dir $pos end]:$aname:$chans"
	}
  }
  return ":::"
}

proc varea2name {{dir ""}} {
  global bot
  foreach {path aname chans} $bot(announce) {
	if [string match "$path*" $dir] {return $aname}
  }
  return ""
}

proc vareaname {{areaname ""}} {
 global bot
 foreach {path aname chans} $bot(announce) {
	if [string equal -nocase $aname $areaname] {
		return "$path:$aname:$chans"
	}
 }
 return "::"
}

proc vareaname2 {{areaname ""}} {
 global bot
 foreach {path aname chans} $bot(announce) {
	if [string equal -nocase $aname $areaname] {
		return $path:$aname
	}
 }
 return ""
}

proc hiddenchk {chan} {
  global allchans bot
  if {$bot(hidden) == 0 || $chan == "//" || [llength $chan] == 2} {
	return
  } elseif {[lsearch $allchans $chan] == -1} {
	putlog "sitestat: NOTICE : ignored user command - undefined channel ($chan)"
	return -code return
  }
}
proc pubcmdchk {chan} {
  global pubcmd site MISC
  if {$pubcmd == "off" && $chan != "//"} {
	tsend chan 5 $chan "$MISC(HED) Public commands are [b]off"
	return 0
  } else {
	return 1
  }
}
proc apubcmdchk {areaname chan} {
 global bot
 if {$chan == "//" || [llength $chan] == 2} {return 1}
 foreach {path aname chans} $bot(announce) {
	if {[string equal -nocase $aname $areaname] && [lsearch $chans $chan] != -1} {
		return 1
	}
 }
 return 0
}

proc nuke {area dir mult reason} {
  ftpe
  set dir [list $dir]
  if ![FTP::Cd $area] {putlog "sitestat: WARNING : nuke failed - couldn't to change to dir ($area)" ; return}
  putlog "> nuking $dir..."
  set reply [FTP::Nuke "$dir $mult $reason"]
##  putlog "ftp: REPLY : $reply"
}


############# control command handlers ########

proc login {state user {group ""} {host ""} {dummy ""}} {
	global bot site allchans defgrp igroups showlogins MISC
	if {$showlogins == 0 || [loginchk $user]} {return}
	set pubchans $site(spchans)
	if {$pubchans == ""} { 
		return 
	} elseif {$pubchans == "all"} {
		set pubchans $allchans
	}
	set reply [split [FTP::Quote SITE USER $user] "\n"]
	foreach line $reply {
		if {[string range $line 0 13] == "200- | Groups:"} {
			set group "[lindex $line 3]" ; break
		}
	}
##putlog "LOGGGGGGGGGIIIIIIIIIINNNNNNNN: $group"
	if {$group == "|" || $group == ""} {set group $defgrp}
	if {[lsearch $igroups $group] != -1} {return}
	set host [string map "<UNKNOWN> *" $host]
	set str "$MISC(HED) LOG$state - [b]$user[b]/[u]$group[u] from $host"

	tsend pub 0 $pubchans $str
}

proc upnuke {type dir info} {
	global nukebuf site aflags NUKE UNNK NUKS
	ftpe
	foreach {area dpath areaname pubchans} [split [varea $dir] ":"] {}
	if {$area == ""} {
		putlog "sitestat: NOTICE : activity ignored - area not defined ($area)" ; return
	} else {
		set ddp [string last "/" $dpath]
		set poo [string range $dpath 0 $ddp]
		set curdir "$area$poo" ; incr ddp
		set updir [string range $dpath $ddp end]
	}
	if {$type == "UNUK"} {set type "UNNUKE"}
	set racemsg ""; set dirsize 0 ; set arrn $areaname
####	putlog "> nuke info - $dpath *$mult* by $user ($info)"
	set useri [lindex $info 0]
	foreach {nuker nukee mult reason} $useri {}
	set now [clock seconds] ; set nowt [clock format $now -format %H:%M:%S]
	if [loginchk $nuker] {set nuker "Autonuker"}
	set mult [lindex $mult 0]
	putlog "\[DIR : [set type]D\] $dpath \[$nuker\]"
	foreach useri $info {
		foreach {nuker nukee mt reason} $useri {}
		set mt [lindex $mt 1]
		set dirsize [expr $dirsize+$mt]
		append racemsg " $nukee:[fixsm $mt]"
	}
	set skinmap "\[b\] \002 \[u\] \037 \[c\] \003 \[r\] \026 \[o\] \{\015\} %size% [fixsm $dirsize] %mult% $mult %now% $nowt %reason% \{$reason\} %nuker% \{$nuker\} %area% $areaname %path% \{$poo\} %site% \{$site(name)\} %nukee% \{$racemsg\} %dir% \{$updir\} %rel% \{$dpath\}"
	if [string match $type "UNNUKE"] {
		if ![info exists UNNK($areaname)] {set arrn "default"}
		set strg [string map $skinmap $UNNK($arrn)]
	} else {
		if ![info exists NUKE($areaname)] {set arrn "default"}
		set strg [string map $skinmap $NUKE($arrn)]
	}
	tsend pub 4 $pubchans $strg
	ssc LASTNKS _ $nuker $dpath $areaname
	fbe::NADD $areaname $updir $nuker _ _ _
	if {[array names NUKS $areaname] == ""} {set areaname "default"}
	if {$NUKS($areaname) != ""} {tsend pub 4 $pubchans [string map $skinmap $NUKS($areaname)]}
}

proc updatedb {command dir user group tagline} {
	global idlestamp w2ign site igroups bot nuke ftpbuf defgrp deftag usertake aflags NEW DATE DEL PRE DUPE DELA
	putlog "sitestat: updatedb invoked - $command"
	set newk "GOOD"
putlog ">>>> $command"
	if {$tagline == ""} {set tagline $deftag}
	if {$group == ""} {set group $defgrp}
	if {[lsearch $igroups $group] == -1} {
		foreach {area dpath areaname pubchans} [split [varea $dir] ":"] {}
		if {$area == ""} {
			putlog "sitestat: NOTICE : activity ignored - area not defined ($area)" ; set command "none"
		} else {
			set ddp [string last "/" $dpath]
			set poo [string range $dpath 0 $ddp]
			set curdir "$area$poo" ; incr ddp
			set updir [string range $dpath $ddp end]
			set now [clock seconds] ; set nowt [clock format $now -format %H:%M:%S] ; set arrn $areaname
			set skinmap "\[b\] \002 \[u\] \037 \[c\] \003 \[r\] \026 \[o\] \{\015\} %now% $nowt %user% \{$user\} %grp% \{$group\} %tag% \{$tagline\} %area% $areaname %site% \{$site(name)\} %path% \{$poo\} %dir% \{$updir\} %rel% \{$dpath\}"
		}
	} else {
		putlog "sitestat: NOTICE : activity ignored - hidden group ($group)" ; set command "none"
	}
####################################################################
	if {$command == "NEW"} {
		set dupeval "GOOD" ; set newk "GOOD"
		if [loginchk $user] {
			if {[string length $updir] < 5} {
				set fbmode 5
			} elseif [string match "*NUKED*" $dpath] {
				set fbmode 6
			} else {
				set fbmode 0
			}
		} else {
			set fbmode 0
			set newk [fbe::nukecheck $areaname $updir]
			set dupeval [fbe::GET $areaname $updir]
			if {$newk == "GOOD"} {
				if {$dupeval != "GOOD"} {set nukeval [fbe::NGET $areaname $updir]} else {set nukeval $dupeval}

				if {$dupeval != "GOOD" && $nukeval == "GOOD"} {
					set fbmode 1
					set newk "DUPE"
					if {$nuke(dupe) == 1} {set fbmode 3} 
				} elseif {$nukeval != "GOOD" && $nuke(renuke) == 1} {
					set fbmode 3
					set newk "PRE-NUKED"
				} else {
					set fbmode 0
				}
			} else {
				if {$nuke(warn) == 0} {
					set fbmode 3
				} else {
					set fbmode 2
					set dupeval [fbe::GET $areaname $updir]
					if {$dupeval != "GOOD"} {set newk "DUPE"}
				}
			}
			if {$fbmode == 3} {incr fbmode -$nuke(warn)}
			if {$fbmode == 3} {incr fbmode $nuke(del)}
		}
		switch $fbmode {
			6 {}
			5 {
				if {[array names DATE $areaname] == ""} {set arrn "default"}
				tsend pub 1 $pubchans [string map $skinmap $DATE($arrn)] 
				putlog "\[DIR : DATE\] $areaname dated dir \[$updir\]"
			}
			4 {
				if {$dupeval != "GOOD"} {
					if ![info exists DUPE($areaname)] {set arrn "default"}
					tsend pub 1 $pubchans [string map $skinmap $DUPE($arrn)]
					ssc LASTDPS _ $user "$dpath" $areaname
					set ftpbuf(autonuker-[fixstr $dpath]) "DUPE"
				} else {
					if ![info exists NEW($areaname)] {set arrn "default"}
					tsend pub 1 $pubchans [string map $skinmap $NEW($arrn)]
					set ftpbuf(autonuker-[fixstr $dpath]) $newk
				}
				putlog "\[DIR : AUTORMD\] $dpath"
				ftpe
				FTP::Cd $curdir
				if {[lrange [FTP::Quote site wipe -R [list $updir]] 0 2] == "200 Can't wipe:"} {nuke $curdir $updir 1 "failed.to.remove"}
			}
			3 {
				if {$dupeval != "GOOD"} {
					if ![info exists DUPE($areaname)] {set arrn "default"}
					tsend pub 1 $pubchans [string map $skinmap $DUPE($arrn)]
					putlog "\[DIR : DUPE\] $dpath \[$user\]"
					ssc LASTDPS _ $user "*AUTONUKED* $dpath" $areaname
				} else {
					if ![info exists NEW($areaname)] {set arrn "default"}
					tsend pub 1 $pubchans [string map $skinmap $NEW($arrn)]
					putlog "\[DIR : AUTONUKE\] $dpath \[$user\]"
					ssc LASTUPS _ $user "*AUTONUKED* $dpath" $areaname
				}
				if {$newk == "PRE-NUKED"} {append newk ".on.[string trim [lindex $nukeval 2] \002]"}
				nuke $curdir $updir $nuke(mult) $newk
			}
			2 {
				if {$newk == "PRE-NUKED"} {set newk $nukeval}
				if ![info exists NEW($areaname)] {set arrn "default"}
				tsend pub 1 $pubchans [string map $skinmap $NEW($arrn)]
				tsend pub 1 $pubchans "[b]>> Warning![b]  Possible [b]NUKE[b] ($newk)"
				putlog "\[DIR : WARNING\] $dpath \[$user\]"
				ssc LASTUPS _ $user $dpath $areaname
			}
			1 {
				if ![info exists DUPE($areaname)] {set arrn "default"}
				tsend pub 1 $pubchans [string map $skinmap $DUPE($arrn)]
				tsend pub 1 $pubchans "[b]>> [b]Dupe of: $dupeval"
				putlog "\[DIR : DUPE\] $dpath \[$user\]"
				ssc LASTDPS _ $user $dpath $areaname
			}
			0 {
				if ![info exists NEW($areaname)] {set arrn "default"}
				tsend pub 1 $pubchans [string map $skinmap $NEW($arrn)]
				putlog "\[DIR : NEW\] $dpath \[$user\]"
				ssc LASTUPS _ $user $dpath $areaname
			}

		}

		if {$fbmode < 4} {fbe::ADD $areaname $dpath $fbmode $user [clock seconds]}
	} elseif {$command == "PRE"} {
		set tagline [split $tagline "/"] ; set cdtxt ""
		foreach {pregrp cnt megs cds} $tagline {}
		if {$cds > 1} {set cdtxt " CDs: [b]$cds[b]"}
		append skinmap " %megs% [fixss $megs] %cnt% $cnt %pregrp% \{$pregrp\}"
		if {[array names PRE $areaname] == ""} {set arrn "default"}
		tsend pub 1 $pubchans [string map $skinmap $PRE($arrn)]

		putlog "\[DIR : PRE\] $dpath"
		fbe::ADD $areaname $dpath 0 default $now
		ssc LASTPRE _ $nowt $dpath $areaname

	} elseif {$command == "WIPE"} {
		set ddir "autonuker-[fixstr $dpath]"
		if {![loginchk $user] && [string first "NUKED" $updir] == -1 && [regexp "d" $aflags($areaname)]} {
			if {[array names DEL $areaname] == ""} {set arrn "default"}
			tsend pub 3 $pubchans [string map $skinmap $DEL($arrn)]
		} elseif [info exists ftpbuf($ddir)] {
			append skinmap " %reason% \{$ftpbuf($ddir)\}"
			if {[array names DELA $areaname] == ""} {set arrn "default"}
			tsend pub 3 $pubchans [string map $skinmap $DELA($arrn)] 
			unset ftpbuf($ddir)
		}
		putlog "\[DIR : DELETED\] $dpath -> $user"
	} elseif {$command == "DEL"} {
		if [regexp "d" $aflags($areaname)] {
			if {[array names DEL $areaname] == ""} {set arrn "default"}
			tsend pub 3 $pubchans [string map $skinmap $DEL($arrn)]
		}
		putlog "\[DIR : DELETED\] $dpath -> $user"
		fbe::DEL $areaname $dpath
	}
	putlog "sitestat: updatedb completed successfully"
}


proc literal {type dir {str ""} {blah ""}} {
	global site bot
	ftpe
	putlog "sitestat: LITERAL : $type"
	if {$str != ""} {
		foreach {area dpath areaname pubchans} [split [varea $dir] ":"] {}
		if {$area == ""} {
			putlog "sitestat: NOTICE : activity ignored - area not defined ($area)"
		} else {
			set ddp [string last "/" $dpath]
			set curdir "$area[string range $dpath 0 $ddp]" ; incr ddp
			set updir [string range $dpath $ddp end]
		}
		tsend pub 5 $pubchans $str
	} else {
		tsend pub 0 $site(spchans) [string trim $dir]
	}
}

proc trialh {user state info {blah ""}} {
	global site bot showtrials userkill MISC
####putlog "user $user state $state info $info blah $blah"
	if {$showtrials == 0} {return}
	set chans $site(spchans)
	if {$chans == ""} {
		return 
	} elseif {$chans == "all"} {
		set chans $allchans
	}
	foreach {alup nukes plan} $info {}
	foreach {tdays tnukes tmegs} [split $plan ":"] {}
	set str "$MISC(HED) TRIAL : "
	switch $state {
		PASSED {append str "[b]$user[b] has completed the trial requirements: [b]$alup/$tmegs[b]MB in [b]$tdays[b]days [b]\]"}
		FAILED {
			if {$nukes >= $tnukes} {
				append str "[b]$user[b] has FAILED the trial! TOO DAMN MANY NUKES!"
			} else {
				append str "[b]$user[b] has FAILED to upload the required [b]$tmegs[b]MB in [b]$tdays[b]days"
			}
			if {$userkill == 1} {FTP::Quote site deluser $user}
		}
	}
	tsend pub 0 $chans $str 
}

proc sfvh {command dir user {group ""} {tagline ""} {other ""}} {
	global aflags idlestamp dnfo site bot usertake m3n deftag igroups remap incs HALF RACE INC COMP CID3 SFV INCD MISC
##putlog "::::: $command ::: $dir :: $user : $group : $tagline : $other"
	ftpe
	foreach {area dpath areaname pubchans} [split [varea $dir] ":"] {}
	if {$area == ""} {
		putlog "sitestat: NOTICE : activity ignored - area not defined ($area)" ; set command "none"
	} else {
		set ddp [string last "/" $dpath]
		set poo [string range $dpath 0 $ddp]
		set curdir $area ; append curdir $poo" ; incr ddp
		set updir [string range $dpath $ddp end]
	}
	set zpath [fixbr $dpath]
	if ![info exists incs($areaname)] {set incs($areaname) ""}
	if ![info exists m3n($zpath)] {set m3n($zpath) ""}
####################################################################
	set now [clock seconds] ; set nowt [clock format $now -format %H:%M:%S] ; set arrn $areaname
	set skinmap "\[b\] \002 \[u\] \037 \[c\] \003 \[r\] \026 \[o\] \{\015\} %now% $nowt %area% $areaname %site% \{$site(name)\} %path% \{$poo\} %dir% \{$updir\} %rel% \{$dpath\}"
	if {$command == "SFV" && [regexp "s" $aflags($areaname)]} {
		append skinmap " %exp% $user"
		putlog "\[UPLOAD : SFV\] $dpath -> ($user files)"
		set str $incs($areaname)
		if {[llength $str] > 10} {set incs($areaname) [lrange $str 1 end]}
		lappend incs($areaname) $zpath
		if {[array names SFV $areaname] == ""} {set arrn "default"}
		tsend pub 2 $pubchans [string map $skinmap $SFV($arrn)]
	} elseif {$command == "INC" && [regexp "i" $aflags($areaname)]} {
		if {[array names INCD $areaname] == ""} {set arrn "default"}
		tsend pub 2 $pubchans [string map $skinmap $INCD($arrn)]
		set str $incs($areaname)
		if {[llength $str] > 10} {set incs($areaname) [lrange $str 1 end]}
		lappend incs($areaname) $zpath
	} elseif {$command == "RACER" && [regexp "n" $aflags($areaname)]} {
#		set user [lindex $user 0]
#		set group [lindex $user 1]
#		set speed [lindex $user 2]
#		set allracers [lindex $user 3]
#####		set allracers $other
		set racemsg ""
		append skinmap " %user% \{$user\} %grp% \{$group\} %tag% \{$tagline\} %speed% \{$tagline\}"
		if ![info exists RACE($areaname)] {set arrn "default"}
 		tsend pub 2 $pubchans [string map $skinmap $RACE($arrn)]
#		foreach racer $allracers {
#			set racer [split $racer "("]
#			append racemsg [b]
#		}
#		tsend pub 2 $pubchans "[b]>> Also racing for the lead:[b] $allracers" 
	} elseif {$command == "INFO" && $tagline != ""} {
		set m3n($zpath) "\{$group\} $tagline $other"
	} elseif {$command == "HALF" && [regexp "h" $aflags($areaname)]} {
		foreach {luser grp megs files perc spd} [split $user /] {}
		set uinfo "[b]$megs[b]MB/[b]$files[b]F/[b]$perc[b]%@[b]$spd[b]KB/s"
		foreach {dummy lgrp megs files perc spd} [split $group /] {}
		set ginfo "[b]$megs[b]MB/[b]$files[b]F/[b]$perc[b]%@[b]$spd[b]KB/s"
		append skinmap " %luser% \{$luser\} %lgrp% \{$lgrp\} %uinfo% \{$uinfo\} %ginfo% \{$ginfo\}"
		if {[array names HALF $areaname] == ""} {set arrn "default"}
		tsend pub 2 $pubchans [string map $skinmap $HALF($arrn)]
		putlog "\[UPLOAD : HALFWAY\] $dpath"
	} elseif {$command == "USTA" && [regexp "u" $aflags($areaname)]} {
		set sven 0 ; regexp \[0-9\] $aflags($areaname) sven
		set wkup ""
		set reply [split [FTP::Quote site wkup 10 $sven] "\n"]
		foreach line [lrange $reply 8 end-2] {
			append wkup "[lindex $line 2] \{[b]\[[string range $line 6 7]\]\} "
		}
		tsend pub 2 $pubchans "[u]Rank  User/Group  (Size Files Percent Speed)[o]"
		set total 0 ; set dirsize 0 ; set avgspeed 0
		foreach wiha $user {
			set week "n/a"
			foreach {rank name grp megs files perc spd} [split $wiha /] {}
			incr total $files ; set dirsize [expr $dirsize + $megs] ; set avgspeed [expr $avgspeed + $spd]
			set pos [lsearch $wkup [string trim $name]] ; incr pos
			if {$pos != 0} {set week [lindex $wkup $pos]} else {set week "none"}
			if {$rank < 10} {set rank "0$rank"}
			set skinmap "\[b\] \002 \[u\] \037 \[c\] \003 \[r\] \026 \[o\] \{\015\} %rank% \{$rank\} %megs% \{$megs\} %files% \{$files\} %perc% \{$perc\} %speed% \{$spd\} %user% \{$name\} %group% \{$grp\} %wkup% \{$week\}  %area% $areaname %site% \{$site(name)\}"
			tsend pub 2 $pubchans [string map $skinmap $MISC(UST)]
		}
		if ![regexp "g" $aflags($areaname)] {
			append skinmap " %total% $total %size% [fixsm $dirsize] %avgspd% $avgspeed"
			tsend pub 2 $pubchans [string map $skinmap $MISC(TST)]
		}
	} elseif {$command == "STAT" && [regexp "g" $aflags($areaname)]} {
		tsend pub 2 $pubchans "[u]Group Statistics[o]"
		foreach wiha $user {
			foreach {rank name grp megs files perc spd} [split $wiha /] {}
			if {$rank < 10} {set rank "0$rank"}
			set skinmap "\[b\] \002 \[u\] \037 \[c\] \003 \[r\] \026 \[o\] \{\015\} %rank% $rank %group% \{$grp\} %megs% \{$megs\} %files% \{$files\} %perc% \{$perc\} %speed% \{$spd\} %area% $areaname %site% \{$site(name)\}"
			tsend pub 2 $pubchans [string map $skinmap $MISC(GST)]
		}
	} elseif {$command == "DONE" && [regexp "c" $aflags($areaname)]} {
		set pos [lsearch $incs($areaname) $zpath]
		if {$pos != -1} {set incs($areaname) [lreplace $incs($areaname) $pos $pos]}
		set dtime [string trim $other]
		putlog "\[UPLOAD : COMPLETE\] $dpath"
		set id3 $m3n($zpath)
		unset m3n($zpath)
		set mp3info ""
		append skinmap " %user% \{$user\} %grp% \{$group\} %tag% \{$tagline\} %time% \{$dtime\} %size% [fixsm $tagline] %id3% \{$mp3info\}" 
		if {$id3 != ""} {
			foreach {genre year bitrate} $id3 {}
			append bitrate "kbit"
			set mp3info "($genre/$year/$bitrate)"
			append skinmap " %id3% \{$mp3info\} %genre% \{$genre\} %rate% $bitrate %year% $year"
			if ![info exists CID3($areaname)] {set arrn "default"}
			tsend pub 2 $pubchans [string map $skinmap $CID3($arrn)]
		} else {
			if ![info exists COMP($areaname)] {set arrn "default"}
			tsend pub 2 $pubchans [string map $skinmap $COMP($arrn)]
		}
		global completecmd1 completecmd2 completecmd3
		if [FTP::Cd $dir] {
			set skinmap "%dir% \{$updir\} %path% \{$dir\} %date% [clock format $now -format %m.%d.%y]" 
			if {$completecmd1 != ""} {FTP::Quote [string map $skinmap $completecmd1]}
			if {$completecmd2 != ""} {FTP::Quote [string map $skinmap $completecmd2]}
			if {$completecmd3 != ""} {FTP::Quote [string map $skinmap $completecmd3]}
		}
	}
} 

proc bnch {cnt pos str} {
  global site bot bnclist bncknt
  set bncknt $cnt
  set curcnt [llength $bnclist]
  if {$curcnt < $bncknt} {
	lappend bnclist $str
  } elseif {$curcnt == $bncknt} {
	set bnclist [lreplace $bnclist $pos $pos $str]
  }
}

############# IRC /MSG commands

proc msgghost {nick uhost hand args} {
   global idlestamp site
   set args [lindex $args 0]
   set user [lindex $args 0]
   set pass [lindex $args 1]
   if {[lverify $user $pass]} {
	set conns [lrange [FTP::Quote SITE kick $user] end-3 end-2]
	set cnt [string index $conns 1]
	if {[lindex $conns 1] == "connections)." && $cnt != 0} {putserv "PRIVMSG $nick :$cnt ghosts killed "}
	putlog "ftp: ghosts killed - $user"
   }
}

proc msgnuke {nick uhost hand args} {
   global idlestamp site bot nukebuf
   set args [lindex $args 0]
   set user [lindex $args 0]
   set pass [lindex $args 1]
   ftpe
   if {$site(nuking) != 1} {putlog "sitestat: user nuke is disabled" ; return}
   if {![lverify $user $pass]} {putlog "sitestat: user nuke failed: invalid user info" ; return}
   set nukeargs [split [lrange $args 2 end] ":"]
   set reply [FTP::Quote SITE unfo $user]
   set reply [split $reply "\n"]
   foreach line $reply {if {[lindex $line 1] == "group"} {set group [split [lindex $line 3] ","] ; break}}

   if {[lsearch [tlow $group] "nukers"] != -1} {
	set area [string trim [lindex $nukeargs 0]]
	set curdir [lindex [split [vareaname2 $area] ":"] 0]
	if {$curdir == ""} {putlog "sitestat: user nuke failed: no such area" ; return 0}

	set dpath [string trim [lindex $nukeargs 1]]
	set pos [string last / $dpath]
	if {$pos != -1} {
		append curdir [string range $dpath 0 $pos]
		set dir [string range $dpath [expr $pos + 1] end]
	} else {
		set dir $dpath
	}
	set mult [string trim [lindex $nukeargs 2]]
	set reason [string trim [lindex $nukeargs 3]]
	set nukebuf([fixbr $dpath]) "$user [lindex $group 0]"
	nuke $curdir $dir $mult $reason
   } else {
     putlog "sitestat: user nuke failed: user not a nuker"
   }
}

proc msginvite {nick uhost hand args} {
   global idlestamp site defgrp igroups MISC
   set chan $site(home)
   if {$site(home) == ""} {putlog "sitestat: user invite is disabled" ; return}
   if {![botisop $chan]} {putserv "PRIVMSG $chan :$MISC(HED) Would it be too much trouble to op me so I could invite some lewser? ..." ; return}
   set args [lindex $args 0]
   set user [lindex $args 0]
   set pass [lindex $args 1]
   ftpe
   if {$chan != "" && [lverify $user $pass]} {
	set reply [split [FTP::Quote SITE USER $user] "\n"]
	foreach line $reply {
		if {[lindex $line 2] == "Groups:"} {set group "[lindex $line 3]" ; break}
	}
	if {$group == "|"} {set group $defgrp}
	if {[lsearch $igroups $group] != -1} {return}
	set now [clock seconds] ; set nowt [clock format $now -format %H:%M:%S]
	set skinmap "\[b\] \002 \[u\] \037 \[c\] \003 \[r\] \026 \[o\] \{\015\} %now% $nowt %nick% \{$nick\} %user% \{$user\} %grp% \{$group\} %site% \{$site(name)\}"
	tsend chan 0 $chan [string map $skinmap $MISC(INV)]
	if {![onchan $nick $chan]} {putserv "INVITE $nick $chan"}
	putlog "sitestat: invited user - $user"
   }
}



############# channel !site commands 

proc sitever {nick uhost hand chan args} {
  global idlestamp ssver site MISC
  tsend chan 5 $chan "$MISC(HED) is using [b]$ssver"
}
proc sitever2 {nick uhost hand chan args} {
  global idlestamp  FLVER FBEVER build site MISC
  tsend chan 5 $chan "$MISC(HED) Sitestat build list: ([b]ss-main $build[b]) ([b]ss-ftplib $FLVER[b]) ([b]ss-fbelib $FBEVER[b])"
}
proc dccsitever {hand idx args} {
  global idlestamp ssver site MISC
  tsend chan 5 "//" "$MISC(HED) is using [b]$ssver"
}
proc dccsitever2 {hand idx args} {
  global idlestamp FLVER FBEVER build site MISC
  tsend chan 5 "//" "$MISC(HED) Sitestat build list: ([b]ss-main $build[b]) ([b]ss-ftplib $FLVER[b]) ([b]ss-fbelib $FBEVER[b])"
}


proc addftpuser {n u h chan args} {
  global allchans bot
  set chan [tlow $chan]
  hiddenchk $chan
  set args [lindex $args 0]
  set nick [lindex $args 0]
  set user [lindex $args 1]
  set nh [nick2hand $nick]
  set nick1 [lindex $nick 0]
  if {$nh == ""} {
      putserv "PRIVMSG $chan :[b]=$nick=[b] --> [u]$nick1[u] isn't on the channel, HELLO.."
  } elseif {$nh != "*"} { 
      putserv "PRIVMSG $chan :[b]=$nick=[b] --> [u]$nick1[u] is already known to me"
  } elseif {$user == ""} {
      putserv "PRIVMSG $chan :[b]=$nick=[b] --> [u]$nick1[u] can't be added without a username"
  } else {
	set reply [FTP::Quote site user $user]
	if {[lrange $reply 0 1] == "200 User"} {
		putserv "PRIVMSG $chan :[b]=$nick=[b] --> [u]$nick1[u] can't be added, $user account doesn't exist"
		return
	}
	set u [split [getchanhost $nick $chan] "@"]
        set id [lindex $u 0]
        set host [lindex $u 1]
	set ifip [split $host "."]
	set cnt 0
	if {[llength $ifip] == 4} {
	  foreach ip $ifip {if {$ip >= 0 && $ip < 256} {incr cnt}}
	} 
	if {$cnt != 4} {
          set host [string map "1 ? 2 ? 3 ? 4 ? 5 ? 6 ? 7 ? 8 ? 9 ? 0 ? {???} * {??} *" $host]
	  set pos [string first . $host] ; set w1 [string range $host 0 [expr $pos - 1]] ; set cnt 0
	  foreach letr [split $w1 {}] {
		if {$letr == "?"} {incr cnt}
	  }
	  if {$cnt > 5} {set host "*[string range $host $pos end]"}
	}
	if [adduser $nick "*!$id@$host"] {
		chattr $nick +vp
		if [ssc FTPFLAG GETX $user] {
			putserv "PRIVMSG $chan :[b]=$nick=[b] --> [u]$nick1[u] was added, but [b]$user[b] already exists"
			return
		}
		ssc FTPFLAG SET $user $nick 0
		putserv "PRIVMSG $chan :[b]=$nick=[b] --> [u]$nick1[u] is now added as [b]$user"
		putlog "sitestat: $nick ($user) added for DCC announcing"
	} else {
		putserv "PRIVMSG $chan :[b]=$nick=[b] --> [u]$nick1[u] could not be added, maybe already exists?"
	}
  }
}


proc userhelp2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  userhelp "// [ssidx $hand]" {} "$hand" "//" {}
}
proc userhelp {nick uhost hand chan args} {
  global site cmdpre showlast fnfo nfocmd pubwho bncknt showtrials MISC
  set chan [tlow $chan]
  hiddenchk $chan
  tsend msg 0 $nick "$MISC(HED) Help Request"
  tsend msg 0 $nick "(square bracketed words are required keywords, words in <> must be specified)"
  tsend msg 0 $nick "[b]Basic Commands:"
  if {$fnfo != ""} {tsend msg 0 $nick "$nfocmd : DCC site .nfo file"}
  tsend msg 0 $nick "[set cmdpre]stat : general site stats"
  tsend msg 0 $nick "[set cmdpre]stat \[dayup/daydn/wkup/wkdn/mnup/mndn/alup/aldn\] : user stats"
  tsend msg 0 $nick "[set cmdpre]stat \[gpwk/gpwd/gpal/gpad\] : group stats"
  tsend msg 0 $nick "[set cmdpre]last \[ups/nukes/dupes/pres\] : $showlast most recent"
  tsend msg 0 $nick "[set cmdpre]user <user> : user info"
  tsend msg 0 $nick "[set cmdpre]speed <user> : show a user's current activity"
  tsend msg 0 $nick "[set cmdpre]bw : current bandwidth usage"
  tsend msg 0 $nick "[set cmdpre]who : show who's online"
  if {$bncknt != 0} {tsend msg 0 $nick "[set cmdpre]bnc : show bouncer(s) status"}
  tsend msg 0 $nick "[set cmdpre]rules : show general site rules"
  tsend msg 0 $nick "[set cmdpre]leechers : list users currently downloading"
  tsend msg 0 $nick "[set cmdpre]uploaders : list users currently uploading"
  tsend msg 0 $nick "[set cmdpre]idlers : list users currently doing nothing"
  if {$showtrials == 1} {
    tsend msg 0 $nick "[set cmdpre]trials list : list users currently on trial"
    tsend msg 0 $nick "[set cmdpre]trials view <user> : view a trial user's status"
  }
  tsend msg 0 $nick "[set cmdpre]help2 : advanced commands help"
}

proc morehelp2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  morehelp "// [ssidx $hand]" {} $hand "//" {}
}
proc morehelp {nick uhost hand chan args} {
  global idlestamp site cmdpre nfocmd showlast w2ign bot arealist MISC
  set chan [tlow $chan]
  hiddenchk $chan
  set areola ""
  tsend msg 0 $nick "$MISC(HED) Advanced Help Request"
  tsend msg 0 $nick "[b]Valid Areas are :[b]$arealist"
  tsend msg 0 $nick "[b]Special Commands:"
  tsend msg 0 $nick "[set cmdpre]incs <area> : show last incomplete dirs in the area"
  tsend msg 0 $nick "[set cmdpre]free all : show freespace for all areas"
  tsend msg 0 $nick "[set cmdpre]free <area> : freespace of a specific area only"
  tsend msg 0 $nick "[set cmdpre]search <area> <pattern> : simple search"
  tsend msg 0 $nick "[set cmdpre]search <area> \[only/since\] <MM/DD/YY> <pattern> : advanced search"
  tsend msg 0 $nick "[set cmdpre]dir <area> <dir> : shows info on a dir"
  tsend msg 0 $nick "[b]Operator Commands:"
  tsend msg 0 $nick "[set cmdpre]add <nick> <username> : shortcut to add users for a DCC site channel"
  tsend msg 0 $nick "[set cmdpre]msg <area> <message> : announces message to all chans"
  tsend msg 0 $nick "[set cmdpre]set \[autonuke/autonukedupe/commands/who\] \[on/off\] : change settings"
  if {$chan != "//"} {tsend msg 0 $nick "In DCC/telnet, to list all partyline FTP commands type [b].site help"}
}

proc siteonjoin {nick uhost hand chan args} {
    global idlestamp allchans sonjoin site cmdpre nfocmd owner botnick bot build ssver ownerjoin lastbind MISC
    set chan [tlow $chan]
    putlog "bot: $nick \($hand\) just joined $chan"
    if {[lsearch $allchans $chan] == -1} {return}
    if {$nick == $botnick} {
	putserv "PRIVMSG $chan :[b]=$nick= Sitestat 5.0 RC2 Powered..."
    } elseif {[matchattr $hand "n"] && $ownerjoin} {
	switch [rand 9] {
        	1 {putserv "PRIVMSG $chan :[b]=$nick=[b] sucky sucky fie dolla"}
        	2 {putserv "PRIVMSG $chan :[b]=$nick=[b] oh shit, there goes the channel"}
        	4 {putserv "PRIVMSG $chan :[b]=$nick=[b] 0wnz j3w 4||"}
        	5 {putserv "PRIVMSG $chan :[b]=$nick=[b] I'm too lame to change my onjoin"}
        	7 {putserv "PRIVMSG $chan :[b]=$nick=[b] <-- GOD-EMPER's bitch"}
        	8 {putserv "PRIVMSG $chan :[b]=$nick=[b] Suicide is for wussies, and raiden users!"}
        	default {putserv "PRIVMSG $chan :[b]=$nick=[b] I bow to my master"}
	}
    } elseif {$hand == "*" && $sonjoin} {
	putserv "NOTICE $nick :$MISC(HED) Running [b]$ssver"
	putserv "NOTICE $nick :$MISC(HED) Type [b][set cmdpre]help[b] to view basic commands or [set cmdpre]help2 for advanced"
    }
}

proc announcement {nick uhost hand chan args} {
 global idlestamp allchans bot MISC
 if {$hand != "\*"} {
   set args [lindex $args 0]
   set argarea [lindex $args 0]
   set pubchans1 $allchans
   foreach {path areaname chans} $bot(announce) {
     if {[string match -nocase $areaname $argarea]} {
       set pubchans1 $chans
       set args [lrange $args 1 end]
       break
     }
   }
   tsend pub 5 $pubchans1 "$MISC(HED) [b]<=- NOTICE -=>[b] [u]$hand[u] says [b]$args"
   putlog "announcement: $args"
 }
}

proc showbnc2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  showbnc "// [ssidx $hand]" {} $hand "//" {}
}
proc showbnc {nick uhost hand chan args} {
  global bnclist site showbncs MISC
  set chan [tlow $chan]
  set nick [lindex $nick 0]
  if {![pubcmdchk $chan] || $bnclist == "" || $showbncs == 0} {return}
  if {$chan == "//"} {
	tsend msg 0 $nick "$MISC(HED) BNC list & status..."
	foreach line $bnclist {
	 	tsend 0 msg $nick "$line"
	}
  } elseif {[lsearch $site(spchans) $chan] != -1} {
    set nick [list $nick]
    hiddenchk $chan
    putserv "NOTICE $nick :$MISC(HED) BNC list & status..."
    foreach line $bnclist {
      putserv "NOTICE $nick :$line"
    }
  }
}

proc passalias {n u h c a} {showtr $n $u $h $c "view [lindex $a 0]"}
proc passalias2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  set args [lindex $args 0]
  showtr "// [ssidx $hand]" {} $hand "//" "view $args"
}

proc showtr2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  set args [lindex $args 0]
  set args [lrange [list $args] 1 2]
  showtr "// [ssidx $hand]" {} $hand "//" $args
}
proc showtr {nick uhost hand chan args} {
  global bot site showtrials MISC
  set chan [tlow $chan]
  if {![pubcmdchk $chan] || $showtrials == 0} {return}
  if {$chan == "//"} {
	set usa "=[authget $hand user]="
  } elseif {[lsearch $site(spchans) $chan] == -1} {
	return
  } else {
	set usa "[b]=$nick=[b]"
  }
  set args [lindex $args 0]
  if {[lindex $args 0] == "list"} {
	set reply [split [FTP::Quote site trial list] "\n"]
putlog $reply
	set reply [string range [lindex $reply 2] 5 end]
	if {$reply == ""} {set reply "There are no users on trial right now..."}
	tsend chan 5 $chan "$MISC(HED) Trial user listing"
	tsend chan 5 $chan "[b]>>[b] $reply"

  } elseif {[lindex $args 0] == "view"} {
	set user [lindex $args 1]
	if {$user == ""} {
		tsend chan 5 $chan "$usa This command requires a username to [u]VIEW[u]" ; return
	} else {
		set reply [split [FTP::Quote site trial view $user] "\n"]
		set ts [lrange [lindex $reply 1] 4 6]
		tsend chan 5 $chan "$MISC(HED) Trial user info[b] - [u]$user[u]"

		if {$ts == "appear to be"} {
			tsend chan 5 $chan "[b]>>[b] user ($user) doesn't appear to be on trial..." ; return
		} elseif {$ts == ""} {
			tsend chan 5 $chan "[b]>>[b] user [lrange [lindex $reply 1] 2 3]" ; return
		}
		set upd [lindex $reply 3]
		set upd [lreplace [lrange $upd 1 end] 1 1 "[b][lindex $upd 2][b]"]
		set nuked [lindex [lindex $reply 4] 2]

		tsend chan 5 $chan "[b]>>[b] $upd + Nuked [b]$nuked[b] times -> Time left: $ts"
	}
  } else {
	tsend chan 5 $chan "$usa You must specify [u]LIST[u], or [u]VIEW[u] [u]<username>[u]"
  }

}


proc showinc2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  set args [lindex $args 0]
  set args [lindex $args 1]
  showinc "// [ssidx $hand]" {} $hand "//" $args
}
proc showinc {nick uhost hand chan args} {
  global bot site showtrials incs MISC
  set chan [tlow $chan]
  if {![pubcmdchk $chan]} {return}
  set nick [list $nick]
  set validarea [split [vareaname $args] ":"]
  foreach {area areaname chans} $validarea {}
  if {$chan == "//"} {
	set usa "=[authget $hand user]="
  } else {
	set usa "[b]=$nick=[b]"
  }
  if {$areaname == ""} {
	tsend chan 5 $chan "$usa You must specify a valid area name"
	return
  } elseif ![apubcmdchk [tlow $areaname] $chan] {
	putlog "sitestat: NOTICE : ignored user command - area hidden to channel ($chan)"
	return
  } else {
	set go 0
	tsend msg 0 $nick "$MISC(HED) Latest incomplete dirs in [b]$areaname[b]"
	if ![info exists incs($areaname)] {tsend msg 0 $nick "[b]>>[b] There doesn't seem to be any incomplete dirs right now..." ; return}
	set str $incs($areaname)
	if {$str == ""} {tsend msg 0 $nick "[b]>>[b] There doesn't seem to be any incomplete dirs right now..." ; return}
	set pos [llength $str]
	if {$pos > 5} {set str [lrange $str [expr $pos - 5] end]}
	foreach line $str {
		tsend msg 0 $nick "[b]>[b] $line"
	}
  }
}

proc siteset2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  set args [lindex $args 0]
  set args [lrange $args 1 2]
  siteset "// [ssidx $hand]" {} $hand "//" $args
}
proc siteset {nick uhost hand chan args} {
  global idlestamp pubcmd nuke ssdcol site bot pubwho nukecheck MISC
  set chan [tlow $chan]
  hiddenchk $chan
  set args [string tolower [lindex $args 0]]
  set cmd [lindex $args 0]
  set val [lindex $args 1]
  if {$chan == "//"} {
	set usa "=[authget $hand user]="
  } else {
	set usa "[b]=$nick=[b]"
  }
  if {[lsearch "autonuke autonukedupe who commands" $cmd] == -1} {
    tsend chan 5 $chan "$usa You must specify an option: [u]AUTONUKE[u], [u]AUTONUKEDUPE[u], [u]WHO[u] or [u]COMMANDS[u], and a value: [u]ON[u]/[u]OFF[u]"
    return
  }
  if {$val != "off" && $val != "on"} {
    tsend chan 5 $chan "$usa You didn't specify a valid option value: [u]ON[u] or [u]OFF[u]"
    return
  }
  if {$cmd == "autonuke"} {
    set uautonuke $nukecheck
    switch $val {
      off {set nukecheck 0}
      on {set nukecheck 1}
    }
    tsend chan 5 $chan "$MISC(HED) Autonuker is [b]$val"
    if {$uautonuke != $nukecheck} {reconfig {} {} {}}

  } elseif {$cmd == "who"} {
    set pubwho $val
    tsend chan 5 $chan "$MISC(HED) FTP-WHO command is [b]$val"

  } elseif {$cmd == "commands"} {
    set pubcmd $val
    tsend chan 5 $chan "$MISC(HED) Public commands are [b]$val"

  } elseif {$cmd == "autonukedupe"} {
    switch $val {
      off {set nuke(dupe) 0}
      on {set nuke(dupe) 1}
    }
    tsend chan 5 $chan "$MISC(HED) Dupe Autonuker is [b]$val"
  }
}

proc sitedir2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  set args [lindex $args 0]
  set pos [string length [lindex $args 0]]
  incr pos
  set args [string range $args $pos end]
  sitedir "// [ssidx $hand]" {} $hand "//" $args
}
proc sitedir {nick uhost hand chan args} {
  global idlestamp site bot symlinks MISC
  set chan [tlow $chan]
  if ![pubcmdchk $chan] {return}
  hiddenchk $chan
  if {$chan == "//"} {
	set usa "=[authget $hand user]="
  } else {
	set usa "[b]=$nick=[b]"
  }
  set args [lindex $args 0]
  set area [tlow [lindex $args 0]]
  set pos [string length $area]
  set dir [string trim [string range $args $pos end]]
  set validarea [split [vareaname $area] ":"]
  foreach {path areaname chans} $validarea {}
  ftpe
	if {$areaname == "" || $dir == ""} {
		tsend chan 5 $chan "$usa You must specify a valid area name and a directory"
		return
	}
	if ![apubcmdchk $area $chan] {
		putlog "sitestat: NOTICE : ignored user command - area hidden to channel ($chan)"
		return
	}
	FTP::Cd $path
	foreach deer [split $dir "/"] {
		set rct [FTP::Cd $deer]
		if {!$rct} {tsend chan 5 $chan "$usa Invalid Directory" ; return 0}
	}
	set dirsize 0
	tsend msg 0 $nick "$MISC(HED) Directory stats"
	tsend msg 0 $nick "[b]> [lindex $dir 0][b] in [b]$area"
putlog "> checking dir..."
	set nchecked [ncheck . 1]
	set stats [lindex $nchecked 0]
	set filecnt [lindex $nchecked 1]
	set odirs [lindex $nchecked 2]
	set dirsize [lindex $nchecked 3]

	foreach dir $odirs {
		if {$dir == "" || [string match *NUKED* $dir] || ![FTP::Cd $dir]} {continue}
		set nchecked [ncheck . 1]
		if {[lindex $nchecked 0] == ""} {continue}
		set stats2 [lindex $nchecked 0]
		set stats [doble $stats $stats2]
		incr filecnt [lindex $nchecked 1]
		set odirs2 [lindex $nchecked 2]
		incr dirsize [lindex $nchecked 3]

		foreach dir1 $odirs2 {
			if {$dir1 == "" || ![FTP::Cd $dir1]} {continue}
			set nchecked [ncheck . 1]
			if {[lindex $nchecked 0] == ""} {continue}
			set stats2 [lindex $nchecked 0]
			set stats [doble $stats $stats2]
			incr filecnt [lindex $nchecked 1]
			incr dirsize [lindex $nchecked 3]
			FTP::Cd ..
		}
		FTP::Cd ..
	}
	foreach {fown fsize} $stats {
		if {$fsize > 0} {			
			tsend msg 0 $nick "[b]>[b] $fown [b]([b][fixss $fsize] - [b][wanfoo $fsize $dirsize][b]%[b])"
		}
	}
	tsend msg 0 $nick "[b]>-->[b] Total size: [fixss $dirsize]"
}



proc sitelast2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  set args [lindex $args 0]
  set args [lrange $args 1 2]
  sitelast "// [ssidx $hand]" {} $hand "//" $args
}
proc sitelast {nick uhost hand chan args} {
  global idlestamp site showlast warinc1 warinc2 bot cmdpre MISC
  set chan [tlow $chan]
  hiddenchk $chan
  if ![pubcmdchk $chan] {return}
  if {$chan == "//"} {
	set usa "=[authget $hand user]="
  } else {
	set usa "[b]=$nick=[b]"
  }

  set args [lindex $args 0]
  set wtype [tlow [lindex $args 0]]
  set ttype [lindex $args 1]
  if {$ttype > 0 && $ttype < [expr $showlast * 2]} {} else {set ttype $showlast}
  if {$wtype == "ups"} {
    set wtvar [ssc LASTUPS GET] ; set wtdis "Uploads"

  } elseif {$wtype == "nukes"} {
    set wtvar [ssc LASTNKS GET] ; set wtdis "Nukes"
  } elseif {$wtype == "dupes"} {
    set wtvar [ssc LASTDPS GET] ; set wtdis "Dupes"
  } elseif {$wtype == "pres"} {
    set wtvar [ssc LASTPRE GET] ; set wtdis "Pres"
  } else {
    tsend chan 5 $chan "$usa You must specify: [u]UPS[u], [u]DUPES[u], [u]PRES[u], or [u]NUKES"
    return
  } 
  if {[llength $wtvar] < $ttype} {set ttype [llength $wtvar]}
  tsend msg 0 $nick "$MISC(HED) Last $ttype [b]$wtdis"
  set x 0
  foreach lastup $wtvar {
    if {$ttype <= $x} {break} 
    set y [expr $x + 1]
    if {$y < 10} {set y "0$y"}
    set lastup [lindex $wtvar $x] ; incr x
    tsend msg 0 $nick "[b]<$y>[b] [lindex $lastup 2] ([b][lindex $lastup 3][b]) [lindex $lastup 0] - [b][lindex $lastup 1]"
  }
}


proc sitesearch2 {hand idx args} {
  if ![matchattr $hand +V] {return}
  set args [lindex $args 0]
  set pos [string length [lindex $args 0]]
  incr pos
  set args [string range $args $pos end]
  sitesearch "// [ssidx $hand]" {} $hand "//" $args
}
proc sitesearch {nick uhost hand chan args} {
  global idlestamp allchans uploadsdb site pubcmd w2ign bot showlast pubcmd MISC
  set chan [tlow $chan]
  hiddenchk $chan
  if ![pubcmdchk $chan] {return}
  set args [tlow [lindex $args 0]]
  set area [lindex $args 0] ; set go 0
  if {$chan == "//"} {
	set usa "=[authget $hand user]="
  } else {
	set usa "[b]=$nick=[b]"
  }
  if ![apubcmdchk $area $chan] {
	putlog "sitestat: NOTICE : ignored user command - area hidden to channel ($chan)"
	return
  }
  set act [lindex $args 1]
  set area [lindex [split [vareaname2 $area] :] 1]
  if {$area == "" || $act == ""} {tsend chan 5 $chan "$usa This command requires a valid area name and search pattern" ; return}
  if {$act == "since"} {
    set finddate [lindex $args 2]
    set sdt [clock scan $finddate]
    set fdt [clock seconds]
    set findpath [lrange $args 3 end]
  } elseif {$act == "only"} {
    set finddate [lindex $args 2]
    set sdt [clock scan $finddate]
    set fdt [expr $sdt + 86400]
    set findpath [lrange $args 3 end]
  } else {
    set act "all"
    set findpath [lrange $args 1 end]
  }
####putlog "> search requested on $findpath... between $sdt and $fdt"
  if {$findpath == "" || [regexp {[/\?:;\*]} $findpath]} {
	tsend chan 5 $chan "$usa This command requires a valid search pattern" ; return
  } else {
	set findpath "\*[string map {{ } *} $findpath]\*"
  }

  tsend msg 0 $nick "$MISC(HED) Scanning for pattern"
  tsend msg 0 $nick "[b]> $findpath[b] in [b]$area"

  set results [fbe::GET $area $findpath 1]
  if {$results == "GOOD"} {
     tsend msg 0 $nick "Listed [b]0[b] matches found"
  } else {
     set cnt 0 ; set cunt 0 ; set cant 0
putlog "> search result max = $showlast"
     foreach line $results {
        set timestamp [lindex $line 0]
	if {$act == "all"} {
	} elseif {$timestamp >= $sdt && $timestamp <= $fdt} {
        } else {
          incr cant ; continue
        }
	incr cunt
        set dir [lindex $line 1]
        set user [lindex $line 2]
        if {$cnt < $showlast} {
		incr cnt
                if {$cnt < 10} {set bcnt "0$cnt"} else {set bcnt $cnt}
                tsend msg 0 $nick "[b]<$bcnt>[b] [gedate $timestamp] ([b]$area[b]) $dir - [b]$user"
	}
     }
     set totalf [expr $cunt - $cnt]
     if {$totalf != 0} {set cnt "(Not displayed: $totalf)"} else {set cnt ""}
     if {$act == "all"} {
       tsend msg 0 $nick "[b]>-->[b] Listed matches found [b]$cunt[b] $cnt"
     } else {
       tsend msg 0 $nick "[b]>-->[b] Listed matches found within timeframe: [b]$cunt[b], matches outside [b]$cant[b] $cnt"
     }
  }
}

proc sitestat2 {hand idx args} {
  global lastbind
  if ![matchattr $hand +V] {return}
  set args [lindex $args 0]
  set args [lrange $args 1 2]
#putlog "LASTBIND :::: $lastbind"
  sitestat "// [ssidx $hand]" {} $hand "//" $args
}
proc sitestat {nick uhost hand chan args} {
  global idlestamp site dnfo nuke bot pubwho nukecheck totalspace lowspacewarn allowrules igroups showlast MISC

  set chan [tlow $chan]
  hiddenchk $chan
  if ![pubcmdchk $chan] {return}
  set args [lindex $args 0]
  set csl [llength $args]
  set cmd [tlow [lindex $args 0]]
  ftpe
  if {$chan == "//"} {
	set usa "=[authget $hand user]="
  } else {
	set usa "[b]=$nick=[b]"
  }
  if {$cmd == "" || $cmd == "bw123"} {
    set ee [getwho]
    if {$ee == ""} {tsend chan 5 $chan "$usa ERROR processing request" ; return}
    if {$cmd == ""} {
	tsend msg 0 $nick "$MISC(HED) Site stats"
	tsend msg 0 $nick "[b]Current traffic:"
    }
    set dlos 0 ; set ulos 0
    set dloc 0 ; set uloc 0
    set idler 0 ; set totalusers 0
    
    foreach {name group tagline state speed action} $ee {
	if {[loginchk $name] || [lsearch $igroups $group] != -1} {continue}
######	if {$action == ""} {break}
	switch $state {
		dnld {
		  incr dloc ; set dlos [expr $dlos + $speed]
		}
		upld {
		  incr uloc ; set ulos [expr $ulos + $speed]
		}
		idle {incr idler}
	}
	incr totalusers
    }
    if {$cmd != ""} {
	set now [clock seconds] ; set nowt [clock format $now -format %H:%M:%S]
	set skinmap "\[b\] \002 \[u\] \037 \[c\] \003 \[r\] \026 \[o\] \{\015\} %now% $nowt %idle% $idler %userson% $totalusers %upcnt% $uloc %upbw% $ulos %dncnt% $dloc %dnbw% $dlos %cnt% [expr $dloc+$uloc] %bw% [expr $dlos+$ulos] %site% \{$site(name)\}"
	tsend chan 5 $chan [string map $skinmap $MISC(BW)]
    } else {
	tsend msg 0 $nick "[b]>->[b] Uploads:[b] $uloc [b]at[b] $ulos[b]K/s"
	tsend msg 0 $nick "[b]>->[b] Downloads:[b] $dloc [b]at[b] $dlos[b]K/s"
	tsend msg 0 $nick "[b]>->[b] Idlers: [b]$idler"
	tsend msg 0 $nick "[b]>[b] Total Users currently online:[b] $totalusers"
	tsend msg 0 $nick "[b]>->[b] Races: [b][llength [array names dnfo]]"
	tsend msg 0 $nick "[b]Sitestat Configuration:"
	if {$nuke(dupe) == 1} {set active "Active"} else {set active "Inactive"}
	tsend msg 0 $nick "[b]>[b] Autonuke Dupes: [b]$active"
	if {$nukecheck} {set active "Active"} else {set active "Inactive"}
	tsend msg 0 $nick "[b]>[b] Autonuker: [b]$active"
    }
  } elseif {$cmd == "who123"} {
    if {$pubwho == "off"} {tsend chan 5 $chan "$usa !sitewho command is [b]$pubwho" ; return 0}
    set ee [getwho]
    if {$ee == ""} {tsend chan 5 $chan "$usa ERROR processing request" ; return}
    set action "" ; set goo 0 ; set uspd 0 ; set dspd 0
    tsend msg 0 $nick "$MISC(HED) Users online"
    foreach {name group tagline state speed action} $ee {
	if {[loginchk $name] || [lsearch $igroups $group] != -1} {continue}
	incr goo
	switch $state {
	  upld {
		set uspd [expr $uspd + $speed]
		tsend msg 0 $nick "[b]> $name[b]/[u]$group[u] [b]->[b] +$action @[b]$speed[b]K/s"
	  }
	  upld {
		set dspd [expr $dspd + $speed]
		tsend msg 0 $nick "[b]> $name[b]/[u]$group[u] [b]->[b] +$action @[b]$speed[b]K/s"
	  }
	  idle {
		tsend msg 0 $nick "[b]> $name[b]/[u]$group[u] [b]->[b] IDLE $action"
	  }
	}
    }
    if {$goo != 0} {
	tsend msg 0 $nick "[b]>-->[b] Bandwidth Usage: (UP [b]$uspd[b]K/s) (DN [b]$dspd[b]K/s)"
    } else {
	set $goo "no"
    }
    tsend msg 0 $nick "[b]>[b] There are currently [b]$goo[b] users online"
  } elseif {$cmd == "usage"} {
    set ee [getwho]
    if {$ee == ""} {tsend chan 5 $chan "$usa ERROR processing request" ; return}
    set ds 0 ; set dc 0
    set cmd [tlow [lindex $args 1]]
    switch $cmd {
	up {tsend chan 5 $chan "$MISC(HED) Users currently uploading" ; set cmd "upld"}
	le {tsend chan 5 $chan "$MISC(HED) Users currently leeching" ; set cmd "dnld"}
	id {tsend chan 5 $chan "$MISC(HED) Users currently idling" ; set cmd "idle"}
    }
    foreach {name group tagline state speed action} $ee {
	if {[loginchk $name] || [lsearch $igroups $group] != -1} {continue}
	if ![string equal $cmd $state] {continue}
	switch $state {
	  idle {
		  tsend chan 5 $chan "[b]> [b]([b]IDLE $action[b]) - $name[b]/$group"
		  incr dc
	  } 
	  upld {
		  tsend chan 5 $chan "[b]> [b]([b][fixlenr $speed 7][b]K/s) - $name[b]/$group"
		  incr dc ; set ds [expr $ds + $speed]
	  }
	  dnld {
		  tsend chan 5 $chan "[b]> [b]([b][fixlenr $speed 7][b]K/s) - $name[b]/$group"
		  incr dc ; set ds [expr $ds + $speed]
	  }
	}
    }
    switch $cmd {
	idle {tsend chan 5 $chan "[b]>>[b] Total: [b]$dc[b] wasted login slots"}
    	default {tsend chan 5 $chan "[b]>>[b] Total: [b]$dc[b]@[b]$ds[b]K/s"}
    }
  } elseif {$cmd == "rules" && $allowrules == 1} {
	set lines [split [FTP::Quote SITE $cmd] \n]
	tsend chan 5 $chan "$MISC(HED) Processing site rules..."
	set lines [lrange $lines 0 end-1]
	foreach line $lines {
		set pline [string range $line 5 end]
		if {$pline != ""} {putserv "NOTICE $nick :[b]>[b] $pline[o]"}
	}
  } elseif {$cmd == "user123"} {
    set user [lindex $args 1]
    if {$user == ""} {return 0}
	set reply [FTP::Quote SITE USER $user]
	if {[lindex $reply end] == " exist."} {tsend chan 5 $chan "$usa ERROR retrieving user info, [u]$user[u] might not exist" ; return 0}
	set reply [split $reply "\n"]
	tsend msg 0 $nick "$MISC(HED) User information - [b]$user"
	foreach line $reply {
		set part1 [string range $line 0 41]
		set part2 [string range $line 42 end]
		if {[lindex $part1 2] == "Groups:"} {
			set group [lrange $line 3 end-1]
			if {$group == "|"} {set group $defgrp}
			tsend msg 0 $nick "[b]>[b] Group(s): [b]$group"
		} elseif {[lindex $part1 2] == "Ratio:"} {
			tsend msg 0 $nick "[b]>[b] Ratio: [b][lindex $part1 3]"
			tsend msg 0 $nick "[b]>[b] Credit: [fixsm [lindex $part2 1]]"
		} elseif {[lindex $part2 0] == "Last"} {
			tsend msg 0 $nick "[b]>[b] Laston: [lrange $part2 2 end-1]"
		} elseif {[lindex $part1 2] == "Flags:"} {
			set att ""; set flag [split [lindex $part1 3]]
			set allflag "1 {Siteop } 2 {Gadmin } 3 {} 4 {} 5 {} 6 {} 7 {Useredit } A {Nuker } B {} C {Undupe } D {} E {} F {} G {} H {} I {} J {} K {} L {} M {} N {}"
			set att [string map $allflag $flag] ; if {$att == ""} {set att "None"}
			tsend msg 0 $nick "[b]>[b] Special: [b]$att"
		}
	}
  } elseif {$cmd == "speed123"} {
    set user [lindex $args 1]
    set ee [getwho]
    if {$ee == ""} {tsend chan 5 $chan "$usa ERROR processing request" ; return}
    set go 0
    tsend chan 5 $chan "$MISC(HED) User activity[b] - [u]$user[u]"
    foreach {name group tagline state speed action} $ee {
	if {[loginchk $name] || [lsearch $igroups $group] != -1} {continue}
	if ![string equal $name $user] {continue}
	incr go
	switch $state {
	  idle {
		  tsend chan 5 $chan "[b]>[b] Idle: [lrange $action 2 3]"
	  }
	  upld {
		  tsend chan 5 $chan "[b]>[b] Upload: $action @[b]$speed[b]K/s"
	  }
	  dnld {
		  tsend chan 5 $chan "[b]>[b] Download: $action @[b]$speed[b]K/s"
	  }
	  default {}
	}
    }
    if {$go == 0} {
	tsend chan 5 $chan ">[b] $user not active or is not logged in"
    }
  } elseif {[lsearch "wkup wkdn alup aldn" $cmd] != -1} {
    set num [lindex $args 1]
    set num1 [lindex $args 2]
    set title [string map "wkup Weekup wkdn Weekdown alup Allup aldn Alldown" $cmd]
    if {$num > 0 && $num < $showlast} {append cmd " $num"}
    if {$num1 > 0 && $num < $showlast} {append cmd " $num1"}
    set lines [split [FTP::Quote SITE $cmd] \n]
    set lines [lrange $lines 8 end-2]
    tsend msg 0 $nick "$MISC(HED) User $title"
    if {$lines == ""} {
	tsend msg 0 $nick "[b]>[b] Nothing to report"
    } else {
	tsend msg 0 $nick "[u] Rank Username ____ Tagline _______ Files _ Bytes _ Speed "
	foreach line $lines {
		set line [string range $line 5 end]
		tsend msg 0 $nick "[b]>[b] $line"
	}
    }

  } elseif {[lsearch "gpwk gpwd gpal gpad" $cmd] != -1} {
    set num [lindex $args 1]
    set num1 [lindex $args 2]
    set title [string map "gpwk Weekup gpwd Weekdown gpal Allup gpad Alldown" $cmd]
    if {$num > 0 && $num < $showlast} {append cmd " $num"}
    if {$num1 > 0 && $num < $showlast} {append cmd " $num1"}
    set lines [split [FTP::Quote SITE $cmd] \n]
    set lines [lrange $lines 8 end-3]
    tsend msg 0 $nick "$MISC(HED) Group $title"
    if {$lines == ""} {
	tsend msg 0 $nick "[b]>[b] Nothing to report"
    } else {
	tsend msg 0 $nick "[u] Rank _ Abbr. ___ Groupname ______ Files _ Bytes _ Members "
	foreach line $lines {
		set line [string range $line 5 end]
		tsend msg 0 $nick "[b]>[b] $line"
	}
    }
  } elseif {[lsearch "dayup daydn mnup mndn monthup monthdn" $cmd] != -1} {
    if {$cmd == "mndn"} {set cmd "monthdn"
    } elseif {$cmd == "mnup"} {set cmd "monthup"}
    set num [lindex $args 1]
    set num1 [lindex $args 2]
    set title [string totitle $cmd]
    if {$num > 0 && $num < $showlast} {append cmd " $num"}
    if {$num1 > 0 && $num < $showlast} {append cmd " $num1"}
    set lines [split [FTP::Quote SITE $cmd] \n]
    set lines [lrange $lines 5 end-2]
    tsend msg 0 $nick "$MISC(HED) User $title"
    if {$lines == ""} {
	tsend msg 0 $nick "[b]>[b] Nothing to report"
    } else {
	tsend msg 0 $nick "[u] Rank Username ____ Tagline _______ Files _ Bytes _ Speed "
	foreach line $lines {
		set line [string range $line 5 end]
		tsend msg 0 $nick "[b]>[b] $line"
	}
    }
  }
}

proc speedalias {nick uhost hand chan args} { sitestat $nick $uhost $hand $chan "speed123 [lindex $args 0]" }
proc useralias {nick uhost hand chan args} { sitestat $nick $uhost $hand $chan "user123 [lindex $args 0]" }
proc leechalias {nick uhost hand chan args} { sitestat $nick $uhost $hand $chan "usage le" }
proc idlealias {nick uhost hand chan args} { sitestat $nick $uhost $hand $chan "usage id" }
proc upalias {nick uhost hand chan args} { sitestat $nick $uhost $hand $chan "usage up" }

proc bwalias {nick uhost hand chan args} { sitestat $nick $uhost $hand $chan "bw123" }
proc rulesalias {nick uhost hand chan args} { sitestat $nick $uhost $hand $chan "rules" }
proc whoalias {nick uhost hand chan args} { sitestat $nick $uhost $hand $chan "who123" }

proc speedalias2 {hand idx args} {
  set args [lindex $args 0]
  set args [lindex $args 1]
  sitestat "// [ssidx $hand]" {} $hand "//" "speed123 [lindex $args 0]" 
}
proc useralias2 {hand idx args} {
  set args [lindex $args 0]
  set args [lindex $args 1]
  if ![matchattr $hand +V] {return}
  sitestat "// [ssidx $hand]" {} $hand "//" "user123 [lindex $args 0]"
}
proc leechalias2 {hand idx args} {  if ![matchattr $hand +V] {return} ; sitestat "// [ssidx $hand]" {} $hand "//" "usage leechers" }
proc idlealias2 {hand idx args} {  if ![matchattr $hand +V] {return} ; sitestat "// [ssidx $hand]" {} $hand "//" "usage idlers" }
proc upalias2 {hand idx args} {  if ![matchattr $hand +V] {return} ; sitestat "// [ssidx $hand]" {} $hand "//" "usage ups0rs" }
proc rulesalias2 {hand idx args} {if ![matchattr $hand +V] {return} ;  sitestat "// [ssidx $hand]" {} $hand "//" "rules" }
proc whoalias2 {hand idx args} {if ![matchattr $hand +V] {return} ;  sitestat "// [ssidx $hand]" {} $hand "//" "who123" }
proc bwalias2 {hand idx args} {if ![matchattr $hand +V] {return} ;  sitestat "// [ssidx $hand]" {} $hand "//" "bw123" }

proc freealias2 {hand idx args} {
  if ![matchattr $hand +V] {return} 
  set args [lindex $args 0]
  set args [lindex $args 1]
  freealias "// [ssidx $hand]" {} $hand "//" $args
}
proc freealias {nick uhost hand chan args} {
  global idlestamp allchans site bot pubcmd MISC lowspacewarn totalspace
  set chan [tlow $chan]
  hiddenchk $chan
  if ![pubcmdchk $chan] {return}
  set area [tlow [lindex $args 0]] ; set path ""
  set areaname ""
#################################################################### REMOVED TEMP.
  if {$area != "all"} {
	foreach {vpath areaname chans} $bot(announce) {if {$area == [tlow $areaname]} {break}}
	if {$areaname == ""} {tsend chan 5 $chan "[b]=$nick=[b] ERROR - invalid area" ; return 0}
	if ![FTP::Cd $vpath] {tsend chan 5 $chan "[b]=$nick=[b] ERROR - inaccessible dir" ; return 0}
	set megs "0"
	set lines [FTP::List 1 .message]
	foreach line $lines {
	  set megs "0"
	  regexp {\[*[fF][rR][eE][eE](.{1,12}?)\]} $line megs
	  if {$megs == "0"} {continue}
	  regexp {[0-9]+} $megs megs
	  break
	}
	tsend chan 5 $chan "$MISC(HED) Free diskspace in [b]$areaname[b] - \[[fixsm $megs]\]"

  } else {
	set disp "" ; set disp2 "" ; set diskfree "0" ; set lcnt 0
	tsend chan 5 $chan "$MISC(HED) Free diskspace listing"
	set annd [llength $bot(announce)]
	set diskfree ""
	foreach {path areaname chans} $bot(announce) {
		if ![FTP::Cd $path] {
			set megs "*\002ERROR\002*"
		} else {
			set megs "0"
			set lines [FTP::List 1 .message]
			foreach line $lines {
				set megs "0"
				regexp {\[*[fF][rR][eE][eE](.{1,12}?)\]} $line megs
				if {$megs == "0"} {continue}
				regexp {[0-9]+} $megs megs
				break
			}
			set badad 0
			incr badad [lsearch $diskfree $megs]
			incr badad [lsearch $diskfree [expr $megs - 1]]
			incr badad [lsearch $diskfree [expr $megs - 2]]
			incr badad [lsearch $diskfree [expr $megs - 3]]
			incr badad [lsearch $diskfree [expr $megs - 4]]
			if {$badad == -5} {lappend diskfree $megs}
			if {$megs < $lowspacewarn} {
				set megs "*[fixsm $megs]*"
			} else {
				set megs [fixsm $megs]
			}
		}
		if {[expr $annd / 3] >= [expr {$lcnt * 2 - 1}]} {
			append disp "([b]$areaname $megs[b])-"
		} else {
			append disp2 "([b]$areaname $megs[b])-"
		}
	}
	if {$lcnt < [expr $annd / 3]} {
		append disp "-\[[b] Total: [fixsm [madd $diskfree]]/[fixsm $totalspace] [b]\]"
		tsend chan 5 $chan "[b]> $disp"
	} else {
		append disp2 "\[[b] Total: [fixsm [madd $diskfree]]/[fixsm $totalspace] [b]\]"
		tsend chan 5 $chan "[b]> [string range $disp 0 end-1]"
		tsend chan 5 $chan "[b]> $disp2"
	}
  }
}

################### DCC/telnet .site commands

proc sitecmdhandler {hand idx args} {
  if {[string first "@" $hand] != -1} {return}  
  global idlestamp site dccauth nukebuf bot defgrp MISC
  set args [lindex $args 0]
  set cmd [tlow [lindex $args 0]]
  authchk $hand $idx

  ftpe
  putdcc $idx "> ------------"
  if {$cmd == "help"} {
	putdcc $idx "$site(name) available partyline commands"
	putdcc $idx "> .site user <user>"
	if [regexp u $dccauth($hand,flags)] {
		if ![regexp r $dccauth($hand,flags)] {
			putdcc $idx "> .site adduser <user> <pass> <ip> <ip> <ip> ..."
		} else {
			putdcc $idx "> .site adduser <user> <pass> <group> <ip> <ip> <ip> ..."
		}
		putdcc $idx "> .site deluser <user>"
		putdcc $idx "> .site chgrp <user> <group>"
		putdcc $idx "> .site chratio <user> <ratio>"
	}
	if [regexp i $dccauth($hand,flags)] {
		putdcc $idx "> .site addip <user> <ip> <ip> <ip> ..."
		putdcc $idx "> .site delip <user> <ip> <ip> <ip> ..."
	}
	if [regexp d $dccauth($hand,flags)] {
		putdcc $idx "> .site undupe <filename> <filename> <filename> ..."
		putdcc $idx "> .site maskundupe <filemask> <start#-end#>"
	}
	if [regexp c $dccauth($hand,flags)] {
		putdcc $idx "> .site kick <user>"
	}
	if [regexp n $dccauth($hand,flags)] {
		putdcc $idx "> .site nuke <areaname>:<dir>:<multiplier>:<reason>"
	}
	if [regexp r $dccauth($hand,flags)] {
		putdcc $idx "> .site scan <area>"
	}
  } elseif {$cmd == "undupe" && [regexp d $dccauth($hand,flags)]} {
	set filelist [lrange $args 1 end]
	foreach filename $filelist {FTP::Quote site undupe $filename}
	putdcc $idx "> undupe complete"
  } elseif {$cmd == "deluser" && [regexp u $dccauth($hand,flags)]} {
	set user [lindex $args 1]
	if {$user == ""} {putdcc $idx "> invalid user" ; return}
	if ![regexp r $dccauth($hand,flags)] {FTP::Quote SITE EMULATE $dccauth($hand,user)}
	set reply [FTP::Quote SITE deluser $user]
	if {$reply == "200 User ($user) deleted."} {
		putdcc $idx "> user deleted ($user)"
	} else {
		putdcc $idx "> user delete failed"
	}
	FTP::Quote SITE EMULATE $site(login)
	putlog "ftp: user deleted ($user)"
  } elseif {$cmd == "adduser" && [regexp u $dccauth($hand,flags)]} {
	set user [lindex $args 1]
	set pass [lindex $args 2]
	set group $defgrp
	if {$user == "" || $pass == ""} {putdcc $idx "> invalid user or pass" ; return}
	if [regexp r $dccauth($hand,flags)] {
		set group [lindex $args 3]
		set ips [lrange $args 4 end]
	} else {
		FTP::Quote SITE EMULATE $dccauth($hand,user)
		set group $dccauth($hand,group)
		set ips [lrange $args 3 end]
	}
	if {[lrange [FTP::Quote SITE GADDUSER $group $user $pass] 0 3] == "200 User ($user) successfully"} {
		putdcc $idx "> user added ($user/$group)"
	} else {
		putdcc $idx "> user add failed ($user)"
	}
	FTP::Quote SITE EMULATE $site(login)
	putlog "ftp: user added ($user/$group)"
	if {$ips == ""} {return}
	sitecmdhandler $hand $idx "addip $user $ips"
  } elseif {$cmd == "addip" && [regexp u $dccauth($hand,flags)]} {
	set user [lindex $args 1]
	set ips [lrange $args 2 end]
	set reply [FTP::Quote SITE USER $user]
	if {[lindex $reply end] == "exist."} {putdcc $idx "> no such user" ; return}
	set group $defgrp
	foreach line [split $reply "\n"] {
		if {[lindex $line 2] == "Groups:"} {
			set group [lindex $line 3]
			break
		}
	}
	if {![regexp \[rc\] $dccauth($hand,flags)] && $group != $dccauth($hand,group)} {putdcc $idx "> no permission to modify $user" ; return}
	foreach ip $ips {
		if {[lrange [FTP::Quote SITE ADDIP $user $ip] 3 4] == "successfully added"} {
			putdcc $idx "> added ip to $user ($ip)"
		} else {
			putdcc $idx "> add ip failed ($ip)"
		}
	}
  } elseif {$cmd == "delip" && [regexp u $dccauth($hand,flags)]} {
	set user [lindex $args 1]
	set ips [lrange $args 2 end]
	if {$user == "" || $pass == ""} {putdcc $idx "> invalid user or ips" ; return}
	set reply [FTP::Quote SITE USER $user]
	if {[lindex $reply end] == "exist."} {putdcc $idx "> no such user" ; return}
	set group $defgrp
	foreach line [split $reply "\n"] {
		if {[lindex $line 2] == "Groups:"} {
			set group [lindex $line 3]
			break
		}
	}
	if {![regexp \[rc\] $dccauth($hand,flags)] && $group != $dccauth($hand,group)} {putdcc $idx "> no permission to modify $user" ; return}
	foreach ip $ips {
		if {[lrange [FTP::Quote SITE DELIP $user $ip] 3 4] == "removed from"} {
			putdcc $idx "> deleted ip from $user ($ip)"
		} else {
			putdcc $idx "> delete ip failed ($ip)"
		}
	}
  } elseif {$cmd == "kick" && [regexp c $dccauth($hand,flags)]} {
	set user [lindex $args 1]
	if {$user == ""} {return 0}
	set conns [FTP::Quote SITE kick $user]
	if {[lrange $conns 0 1] == "200 Killed"} {
		set conns [lindex $conns 2]
		putdcc $idx "> $user kicked off server - $conns"
	} else {
		putdcc $idx "> $user is not logged in"
	}

  } elseif {$cmd == "chratio" && [regexp u $dccauth($hand,flags)]} {
	set user [lindex $args 1]
	set ratio [lindex $args 2]
	if {$user == "" || $ratio == "" || $ratio > 10 || $ratio < 0} {putdcc $idx "> invalid user or ratio" ; return}
	if {[tlow $ratio] == "leech"} {set ratio 0 ; set vratio "leech"} else {set vratio "1:$ratio"}
	if {[FTP::Quote SITE CHANGE $user ratio $ratio] == "200 Command Successful."} {
		putdcc $idx "> $user ratio set to $vratio"
	} else {
		putdcc $idx "> change ratio failed"
	}

  } elseif {$cmd == "chgrp" && [regexp u $dccauth($hand,flags)]} {
	set user [lindex $args 1]
	set group [lindex $args 2]
	if {$group == "" || $user == ""} {putdcc $idx "> invalid user or group" ; return}
	if {[FTP::Quote SITE chgrp $user $group] == "200- \'$user\' has been successfully added to \'$group\'"} {
		putdcc $idx "> $user group set to $group"
	} else {
		putdcc $idx "> change group failed"
	}

  } elseif {$cmd == "user" && [regexp u $dccauth($hand,flags)]} {
	set user [lindex $args 1]
	if {$user == ""} {putdcc $idx "> invalid user" ; return}
	set reply [FTP::Quote SITE USER $user]
	if {[lindex $reply end] == "exist."} {putdcc $idx "> no such user" ; return}
	set reply [split $reply "\n"]
	foreach line $reply {
		set part1 [string range $line 0 41]
		set part2 [string range $line 42 end]
		if {[lindex $part1 2] == "Groups:"} {
			set group [lrange $line 3 end-1]
			if {$group == "|"} {set group $defgrp}
			putdcc $idx "> Group(s): $group"
		} elseif {[lindex $part1 2] == "Ratio:"} {
			putdcc $idx "> Ratio: [lindex $part1 3]"
			putdcc $idx "> Credit: [lindex $part2 1][lindex $part2 2]"
		} elseif {[lindex $part2 0] == "Last"} {
			putdcc $idx "> Laston: [lrange $part2 2 end-1]"
		} elseif {[lindex $part1 2] == "Flags:"} {
			set att ""; set flag [split [lindex $part1 3]]
			set allflag "1 {Siteop } 2 {Gadmin } 3 {} 4 {} 5 {} 6 {} 7 {Useredit } A {Nuker } B {} C {Undupe } D {} E {} F {} G {} H {} I {} J {} K {} L {} M {} N {}"
			set att [string map $allflag $flag] ; if {$att == ""} {set att "None"}
			putdcc $idx "> Special: $att"
		} elseif [string match "IP?" [lindex $line 0]] {
 			if ![regexp r $dccauth($hand,flags)] {break}

			set line [string map "200- {} | {}" $line]
			putdcc $idx "> $line"
		}
	}
  } elseif {$cmd == "nuke" && [regexp n $dccauth($hand,flags)]} {
	if {$site(nuking) != 1} {putdcc $idx "> MSG/DCC nuking has been disabled" ; return}
	set nukeargs [split [lrange $args 1 end] ":"]

	set area [string trim [lindex $nukeargs 0]]
	set curdir [lindex [split [vareaname2 $area] ":"] 0]
	if {$curdir == ""} {
		putlog "sitestat: user nuke failed - no such area"
		putdcc $idx "> nuke failed - no such area" 
		return
	}
	set dpath [string trim [lindex $nukeargs 1]]
	set pos [string last / $dpath]
	if {$pos != -1} {
		append curdir [string range $dpath 0 $pos] ; incr pos
		set dir [string range $dpath $pos end]
	} else {
		set dir $dpath
	}
	if {$dir == ""} {
		putlog "sitestat: user nuke failed - no such dir"
		putdcc $idx "> nuke failed - no such dir" 
		return
	}
	set mult [string trim [lindex $nukeargs 2]]
	set reason [string trim [lindex $nukeargs 3]]

	if {$mult > 0 && $mult < 11} {} else {set mult 1}
	if {$reason == ""} {set reason "none"}
	set nukebuf([fixbr $dpath]) "$dccauth($hand,user) $dccauth($hand,group)"

	nuke $curdir $dir $mult $reason
  } elseif {$cmd == "scan" && [regexp r $dccauth($hand,flags)]} {
	set area [lindex $args 1]
	set curdir [split [vareaname2 $area] ":"]
	set area [lindex $curdir 1]
	set curdir [lindex $curdir 0]
	foreach areadir [array names symlinks] {
	  if {$symlinks($areadir) == $curdir} {
		append curdir " $areadir"
	  }
	}
	set dirsize 0 ; set odirs "" ; lappend curdir ""
	if {$area == ""} {putidx $idx "> failed to scan - no area specified" ; return}
	foreach pdir $curdir {
	  if {$pdir == "" || ![FTP::Cd $pdir]} {continue}
	  set lines "[FTP::List 0 .] \{\}"
	  foreach line $lines {
		set attrib [string index $line 0]
		if {$attrib != "d"} {continue}
		set pos [expr [string first : $line] + 4]
		set dir [string range $line $pos end]
		if {$dir == "_PRE"} {continue}
		set downer [lindex $line 2]
		set dstamp [clock scan [lrange $line 5 6]]
		fbe::ADD $area $dir 0 $downer $dstamp

		if {![FTP::Cd $dir]} {continue}
		set lines2 "[FTP::List 0 .] \{\}"
		foreach line2 $lines2 {
			set attrib [string index $line2 0]
			if {$attrib != "d"} {continue}
			set pos [expr [string first : $line2] + 4]
			set dir2 [string range $line2 $pos end]
			set downer [lindex $line2 2]
			set dstamp [clock scan [lrange $line2 5 6]]
			fbe::ADD $area "$dir/$dir2" 0 $downer $dstamp
		}
		FTP::Cd ..
	  }
	}
	fbe::FLUSH force
#  } elseif {$cmd == "who" && [regexp u $dccauth($hand,flags)]} {
#	set lines [split [FTP::Quote SITE swho] \n]
#	set lines [lreplace $lines 0 2]
#	set lines [lreplace $lines end-2 end]
#	putdcc $idx "$MISC(HED) users online"
#	foreach line $lines {
#		if [string match "*----------*" $line] {continue}
#		set lbit [string map "{200- |} >" $line]
#		putdcc $idx [string range [string replace $lbit 8 8 "-->"] 0 end-1]
#	}
  } elseif {$cmd == "maskundupe" && [regexp d $dccauth($hand,flags)]} {
	set filemask [lindex $args 1] ; set filelist ""
	set frange [lindex $args 2] ; set frange [split $frange "-"] ; set digits 0
	set pos1 [string first "?" $filemask]
	if {$pos1 != -1} {incr digits}
	set pos2 [string last "?" $filemask]
	if {$pos2 != $pos1} {incr digits ; set pos2 [expr $pos1 + 1]}
	set lowr [lindex $frange 0] ; set hir [lindex $frange 1]
	if {[string length $lowr] == 2 && [string index $lowr 0] == "0"} {set lowr [string index $lowr 1]}
	if {[string length $hir] == 2 && [string index $hir 0] == "0"} {set hir [string index $hir 1]}
	switch $digits {
		1 {
			if {$lowr >= 0 && $lowr < 10 && $hir >= 1 && $hir < 10} {
				for {set x $lowr} {$x <= $hir} {incr x} {append filelist "[string replace $filemask $pos1 $pos1 $x] "}
			} else {
				putdcc $idx "> invalid undupe mask - out of bounds" ; return
			}
		  }
		2 {
			if {$lowr >= 0 && $lowr < 99 && $hir >= 1 && $hir < 100} {
			    for {set x $lowr} {$x <= $hir} {incr x} {
				if {$x < 10} {set y "0$x"} else {set y $x}
				append filelist "[string replace $filemask $pos1 $pos2 $y] "
			    }
			} else {
				putdcc $idx "> invalid undupe mask - out of bounds" ; return
			}
		  }
		default {putdcc $idx "> invalid undupe mask - no characters to substitute" ; return}
	}
	foreach filename $filelist {FTP::Quote site undupe $filename}
	putdcc $idx "> undupe complete"
  }
  set idlestamp 0
}

proc dccauthlog {hand idx args} {
  if {[string first "@" $hand] != -1} {return}
  global idlestamp site dccauth sdaidxlist defgrp
  set args [lindex $args 0]
  set user [lindex $args 0]
  set pass [lindex $args 1]
  ftpe
  if [info exists dccauth($hand,index)] {putdcc $idx "> You are already authorized" ; return}
##################
  if ![lverify $user $pass] {putidx $idx "> Invalid username or password" ; return}
##################
  set cmd [ssc FTPFLAG GET $user $hand]
  if {[lindex $cmd 1] != 1} {putidx $idx "> Invalid username or password" ; return}
  set cmd [lindex $cmd 0]
  set dccauth($hand,user) $user
  set dccauth($hand,index) $idx
  set dccauth($hand,logout) ""
  set reply [split [FTP::Quote SITE USER $user] "\n"]
  set att ""
  foreach line $reply {
	set part1 [string range $line 0 41]
	if {[lindex $part1 2] == "Groups:"} {
		set group [lindex $line 3]
		if {$group == "|"} {set group $defgrp}
	} elseif {[lindex $part1 2] == "Flags:"} {
		set flag [split [lindex $part1 3]]
		set allflag "1 uri 2 u 3 {} 4 {} 5 {} 6 {} 7 ui A n B {} C d D {} E c F {} G {} H {} I {} J {} K {} L {} M {} N {}"
		set att [string map $allflag $flag]
	}
  }
  set dccauth($hand,group) $group
  set dccauth($hand,flags) $att
  sitecmdhandler $hand $idx "help"
  if {$cmd == 0} {
	putdcc $idx "> ------------ "
	putdcc $idx "> Server announcing is currently hidden to you"
	sda $hand $idx "help"
  } else {
	chattr $hand +V
	append sdaidxlist " $idx:$cmd"
  }
}

proc authchk {hand idx} {
  global dccauth
  if ![info exists dccauth($hand,index)] {
	putdcc $idx "> You haven't been authorized: type .login <username> <password>"
	return -code return
  } elseif {$dccauth($hand,index) != $idx} {
	putdcc $idx "> Your authorization has expired: type .login <username> <password>"
	killauth $hand $idx
	return -code return
  }
}

proc killauth {hand idx} {
  global sdaidxlist dccauth
  set items [array names dccauth]
  set yindx -1
  foreach item $items {
	if [string match "$hand,*" $item] {
		if {$item == "$hand,logout"} {
			foreach cmditem $dccauth($hand,logout) {if {$cmditem != ""} {$cmditem}}
		} elseif {$item == "$hand,index"} {
			set yindx [ssidx $hand]
		}
		unset dccauth($item)
##putlog "o0o0o0o $item"
	}
  }
  set pos [lsearch -regexp $sdaidxlist "$yindx:*"]
  if {$pos != -1} {set sdaidxlist [lreplace $sdaidxlist $pos $pos]}
  catch {chattr $hand -V}
}

proc ssidx {hand} {
  global dccauth
  if ![info exists dccauth($hand,index)] {return [hand2idx $hand]}
  return $dccauth($hand,index)
}

proc dcckillauth {hand idx args} {
  global dccauth
  if [info exists dccauth($hand,index)] {putidx $idx "> Logout"}
  killauth $hand $idx
}

proc listlogged {h i a} {
  putdcc $i "> Partyline users logged in - [userlist V]"
}

proc authget {hand item} {
  global dccauth
  if [info exists dccauth($hand,$item)] {return $dccauth($hand,$item)}
  return ""
}
proc authset {hand item {str ""}} {
  global dccauth
  set dccauth($hand,$item) $str
}

proc dccidlepurge {} {global sdaidxlist idlelimit
  if {$sdaidxlist == ""} {return}
  foreach idx $sdaidxlist {
    set idx [lindex [split $idx ":"] 0]
    putlog "sitestat: idle checking ... $idx"
    if ![valididx $idx] {continue}
    set idlet [getdccidle $idx]
    if {$idlet > [expr $idlelimit * 60]} {
	killauth [idx2hand $idx] $idx
    }
  }
}


proc sda {hand idx args} {
  if {[string first "@" $hand] != -1} {return}

  global dccauth sdaidxlist sscact
  set cmd [tlow [lindex $args 0]]
  authchk $hand $idx
  set remap "0 {} 1 { uploads} 2 { races} 3 { deletes} 4 { nukes} 5 { commands}"
  if {$cmd == "help"} {
	putdcc $idx "> -------------"
	putdcc $idx "> Server announcing options allow you to see some announces and not others..."
	putdcc $idx "> available options: 1 (new dir, pre), 2 (racing, halfway), 3 (delete), 4 (nuke, unnuke), 5 (bw, who)" 
	putdcc $idx "> example1: [b].showmsg 145"
	putdcc $idx "> the above example will show only the very important stuff, good for the minimalist"
	putdcc $idx "> example2: [b].showmsg 12345"
	putdcc $idx "> the above example will show everything, and likely what most people want to see"
	putdcc $idx "> example3: [b].showmsg off"
	putdcc $idx "> the above example will prevent you from seeing any announces, including most command replies"
	set cmd ""
  }
  if {$cmd == "off"} {
	set pos [lsearch -regexp $sdaidxlist "$idx:*"]
	if {$pos != -1} {set sdaidxlist [lreplace $sdaidxlist $pos $pos]}
	putdcc $idx "> ------------ "
	putdcc $idx "> Server announcing is currently hidden to you"
	if [matchattr $hand V] {chattr $hand -V}
	ssc FTPFLAG SET $dccauth($hand,user) $hand 0
	set sscact 1
  } elseif {$cmd == ""} {
	set cmd [ssc FTPFLAG GET $dccauth($hand,user) $hand]
	if {[lindex $cmd 1] != 1} {putidx $idx "> Invalid username or password" ; return}
	set cmd [lindex $cmd 0]
	set ntxt [string map $remap $cmd]
	putdcc $idx "> ------------ "
	if {$ntxt == ""} {
		putdcc $idx "> Server announcing is currently hidden to you"
	} else {
		putdcc $idx "> Server announcing currently shows:$ntxt"
	}
  } elseif {![string is integer -strict $cmd]} {
	set pos [lsearch -regexp $sdaidxlist "$idx:*"]
	if {$pos != -1} {set sdaidxlist [lreplace $sdaidxlist $pos $pos]}
	putdcc $idx "> ------------ "
	putdcc $idx "> Server announcing will be hidden to you - invalid option(s) specfied"
	putdcc $idx "> available options: 1 (new dir, pre), 2 (racing, halfway), 3 (delete), 4 (nuke, unnuke), 5 (bw, who)" 
	putdcc $idx "> example: [b].showmsg 145"
	if [matchattr $hand V] {chattr $hand -V}
	ssc FTPFLAG SET $dccauth($hand,user) $hand 0
  } else {
	set ncmd "0"
	if [regexp 1 $cmd] {append ncmd "1"}
	if [regexp 2 $cmd] {append ncmd "2"}
	if [regexp 3 $cmd] {append ncmd "3"}
	if [regexp 4 $cmd] {append ncmd "4"}
	if [regexp 5 $cmd] {append ncmd "5"}
	set ntxt "-[string map $remap $ncmd]"
	putdcc $idx "> ------------ "
	if {$ncmd == "0"} {putdcc $idx "> Server announcing options unchanged" ; return}
	ssc FTPFLAG SET $dccauth($hand,user) $hand $ncmd
	set pos [lsearch -regexp $sdaidxlist "$idx:*"]
	if {$pos == -1} {
	  append sdaidxlist " $idx:$ncmd"
	} else {
	  set sdaidxlist [lreplace $sdaidxlist $pos $pos "$idx:$ncmd"]
	}
	putdcc $idx "> Server announcing is enabled $ntxt"
	if ![matchattr $hand V] {chattr $hand +V}
  }
}


bind bot - ss5inv ihandler
proc ihandler {hand idx args} {
  global botnet-nick site MISC
  set args [lindex $args 0]
  foreach {sbot nick user group chan} $args {}
  set bbot [set botnet-nick]
  set now [clock seconds] ; set nowt [clock format $now -format %H:%M:%S]
  set skinmap "\[b\] \002 \[u\] \037 \[c\] \003 \[r\] \026 \[o\] \{\015\} %now% $nowt %nick% \{$nick\} %user% \{$user\} %grp% \{$group\} %site% \{$site(name)\}"
  if {$sbot == $bbot} {
##putlog ">>$sbot<<"
	if ![botisop $chan] {tsend chan 0 $chan "$MISC(HED) Would it be too much trouble to op me so I could invite some lewser? ..." ; return}
	tsend chan 0 $chan [string map $skinmap $MISC(INV)]
putlog "sitestat: invited user - $nick"
	if ![onchan $nick $chan] {putserv "INVITE $nick $chan"} else {return}
  } else {
	catch {putbot $sbot "\{$nick\} \{$user\} \{$group\} \{$chan\} \{[string map $skinmap $MISC(INV)]\}"} msg
putlog "sitestat: invited user on $sbot - $nick"
	if {$msg == "bot is not in the botnet"} {putlog "sitestat: WARNING : $sbot is unlinked or is not a valid bot" ; return}
  }
}


bind bot - ss5log hhandler
proc hhandler {hand idx args} {
  putlog "[lindex $args 0]"
}

############ used by control bot comms ########
bind bot - ss2cmd ehandler
proc ehandler {hand idx args} {
  set args [lindex $args 0]
####putlog "control bot called -> $args"
  [lindex $args 0] [lindex $args 1] [lindex $args 2] [lindex $args 3]
}

bind bot - ss5cmd fhandler
proc fhandler {hand idx args} {
  set args [lindex $args 0]
###putlog "control bot called -> $args"
 [lindex $args 0] "[lindex $args 1]" "[lindex $args 2]" "[lindex $args 3]" "[lindex $args 4]" "[lindex $args 5]"
}

bind bot - ss6cmd jhandler
proc jhandler {hand idx args} {
  set args [lindex $args 0]
###putlog "control bot called -> $args"
  [lindex $args 0] "[lindex $args 1]" "[lindex $args 2]" "[lindex $args 3]" "[lindex $args 4]" "[lindex $args 5]" "[lindex $args 6]"
}

############ used by echobot comms ########
bind bot - echocmd echoh
proc echoh {hand idx args} {
  set args [lindex $args 0]
####putlog "echobot called -> [lindex $args 0]"
  [lindex $args 0] "$hand [lindex $args 1]" a@b.com * "$hand [lindex $args 4]" "[lindex $args 5]" "[lindex $args 6]"
}

bind bot - echoinv ecoinvh
proc ecoinvh {hand idx args} {
  global site
  if {$site(remote) == ""} {return}
  if {$site(remote) == "all" || [lsearch $site(remote) $hand] != -1} {
	set args [lindex $args 0]
	foreach {user pass nick uhost} $args {}
  	if [lverify $user $pass] {
		putbot $hand "ssxinv \{$user\} \{$nick\} \{$uhost\}"
	}
  }
}

############ multiple target broadcast system #####
proc tsend {mtyp flag dest msg} {
  global dccauth sdaidxlist ssxconn
#putlog ">> $mtyp ?> $flag || $dest (($ssxconn)) << $msg"
  set dest [split $dest " "]
  switch $mtyp {
    msg {
	if {[lindex $dest 0] == "//"} {
	  putdcc [lindex $dest 1] $msg
	} elseif {[llength $dest] > 1} {
putlog "ECHO >> sending [lindex $dest 0] : ss5msg \{[lindex $dest 1]\} \{$msg\}"
	  putbot [lindex $dest 0] "ss5msg \{[lindex $dest 1]\} \{$msg\}"
	} else {
	  putserv "PRIVMSG [lindex $dest 0] :$msg" 
	}
    } 
    pub {
	foreach idx $sdaidxlist {
	  set idx [split $idx ":"]
	  if [regexp $flag [lindex $idx 1]] {putdcc [lindex $idx 0] $msg}
	}
	foreach {bni bnf} $ssxconn {
	  if [regexp $flag $bnf] {putbot $bni "ss5pub \{$msg\}"}
	}
	foreach chan $dest { putserv "PRIVMSG $chan :$msg" }
    } 
    chan {
	if {$dest == "//"} {
	    foreach idx $sdaidxlist {
		set idx [split $idx ":"]
		if [regexp $flag [lindex $idx 1]] {putdcc [lindex $idx 0] $msg}
	    }
	} elseif {[llength $dest] > 1} {
putlog "ECHO >> sending [lindex $dest 0] : ss5msg \{[lindex $dest 1]\} \{$msg\}"
	  putbot [lindex $dest 0] "ss5msg \{[lindex $dest 1]\} \{$msg\}"
	} else {
	  foreach chan $dest { putserv "PRIVMSG [lindex $chan 0] :$msg" }
	}
    }
  }
}

proc setskin {h i args} {
	global defskin
	set args [lindex $args 0]
	append args "_skin.cfg"
	if ![file readable $args] {putdcc $i "> unable to read skin '$args'" ; return}
	set defskin $args
	reconfig {} {} {}
	putdcc $i "> default skin changed to '$args'"
}

proc ddump {h i a} {
  global bot site pre dccauth ssver build FLVER FBEVER predirs ssxlist MISC
  putdcc $i "\[SITESTAT\] - $MISC(HED)"
  putdcc $i "ss-main: $build"
  putdcc $i "ss-ftplib: $FLVER"
  putdcc $i "ss-fbelib: $FBEVER"
  putdcc $i "" 
  putdcc $i "\[ANNOUNCE\]"
foreach {ab bb cb} $bot(announce) {
  putdcc $i "$ab + $bb + $cb"
}
  putdcc $i "" 
  putdcc $i "\[DCCAUTH\]"
foreach ab [array names dccauth] {
  if [string match "*,user" $ab] {
    putdcc $i "$dccauth($ab)"
  }
}
  putdcc $i "" 
  putdcc $i "\[ECHOBOTS\]"
foreach {ab bb} $ssxlist {
  putdcc $i "$ab ($bb)"
}
  putdcc $i "" 
  putdcc $i "###### end debug." 

}

proc lverify {user pass} {
   global idlestamp site
   ftpe
   set reply [lrange [FTP::Quote SITE authpass [list $user] [list $pass]] 0 1]
   if {[string first "No match." $reply] != -1} {
	putlog "sitestat: password verification failed for user: $user"
   } elseif {[string first "Match." $reply] != -1} {
	return 1
   } else {
	putlog "sitestat: WARNING : server failed on authenticate - authpass not defined?"
   }
   return 0
}

proc ftpe {} {
  global ftpr
  if {[expr [clock clicks -milliseconds] - $ftpr] < 1600} {return}
  if {![FTP::Noop]} {
     catch {FTP::Close}
     if {![ftp_login]} {
        putlog "ftp: ERROR : could not connect" 
     }
  } else {
    set idlestamp 0
  }
  set ftpr [clock clicks -milliseconds]
}

proc dccftplogon {hand idx args} {ftp_login}
proc ftp_ctrl {} {
	global idlestamp bot annl site dtasks ftpbuf quotamsg ftpt lowspacewarn allchans MISC ftprocess
	if {$idlestamp < 3} {return}
	set idlestamp 0
	set reply "" ; ftpe ; set bal [llength $bot(announce)]
	if {$annl < 0} {incr annl $bal}
	foreach {dir areaname pubchans} [lrange $bot(announce) $annl [expr $annl + 2]] {}
	set dir [string range $dir 0 end-1]
	incr ftprocess
	incr annl -3
	set bal [expr $bal + 0.0]
	set bal [expr ($ftprocess * $bal) / 100]
##putlog "===> $bal <==="
	set pos [array get dtasks $areaname]
	if ![FTP::Cd $dir] {ftp_login ; return} else {putlog ".....CD $dir"}
	if {[expr int($bal)] >= 1} {set ftprocess 0} else {return}

	switch $ftpt($areaname) {
	  1 {
		set ftpt($areaname) 0
		set lines [FTP::List 1 .message]
		if {$pos != ""} {return}
		foreach line $lines {
		  set megs "0"
		  regexp {\[(.?)[fF][rR][eE][eE](.{1,12}?)\]} $line megs
		  if {$megs == "0"} {continue}
		  regexp {[0-9]+} $megs megs
		  break
		}
		if {$megs < $lowspacewarn} {
			set chan $site(home)
			if {$chan == ""} {set chan [lindex $allchans 0]}
			tsend chan 0 $chan "$MISC(HED) [b]WARNING![b] Low diskspace detected in [u]$areaname[u]: [fixsm $megs]"
		}
	  }
	  0 {
		set ftpt($areaname) 1
		set lines [FTP::List 0 "-tkr ."]
		if {$pos == ""} {return}
		foreach {disth ext} [lindex $pos 1] {break}
		set poo 0
		foreach line $lines {
			incr poo ; if {$poo > 5} {break}
			set tline [split [FTP::Quote site total .] \n]
			set total [expr [lindex [lindex $tline end-1] 1] / 1024]
			putlog "\[QUOTA : STATUS\] $areaname -> $total/$disth"
			if {$total < $disth} {break}
			set name [string range $line 55 end]
			if {$name == "" || [lsearch $ext $name] != -1} {continue}

			set info [string range $line 0 54]
			foreach {attrib blah fown group size month day stamp} $info {}
			if {$blah > 1} {
				putlog "> quota control == $month $day $stamp ($name)"
				set ftpbuf(autonuker-[fixstr $name]) $quotamsg
				FTP::Quote site wipe -R [list $name]
			}
		}
	  }
	}
}


proc ftp_login {} {
  global idlestamp site
  putlog "ftp: attempting to connect..."
  if {[FTP::Open $site(ip) $site(port) !$site(login) $site(pass)]} {
	putlog "ftp: connection established" ; return 1
  } else {
	putlog "ftp: CRITICAL : connection failed" ; return 0
  }
}

proc backupdate {} {
	global idlestamp ueprocess site mdate ssxlist ssxconn
###	if {![info exists mdate]} {mcheck}
	switch $ueprocess {
		2 {
		  set botl [bots]
		  set ssxconn ""
		  foreach {sbot sflg} $ssxlist {
			if {$sbot == ""} {break}
			if {[lsearch $botl $sbot] != -1} {append ssxconn "$sbot $sflg "}
		  }
		}
		4 {fbe::FLUSH}
		6 {}
		8 {scrondito}
		10 {}
		12 {fbe::CLEAN}
		14 {dccidlepurge}
		16 {
		  scrondito
		  set ueprocess 0
		}
		default {sscflush ; incr idlestamp}
	}
	ftp_ctrl
	incr ueprocess
	utimer 5 backupdate
}

proc tieup {h i a} {
	global idlestamp arealist
	putlog "sitestat: CLEANUP invoked - tying up loose ends..."
	fbe::FLUSH force
	fbe::CLEAN force
	putlog "sitestat: CLEANUP complete - its now safe to shutdown (no data will be lost)"
}

proc ssrestart {h i a} { global sscact
  set sscact 1
  sscflush
  set vees [userlist V]
  if {$vees != ""} {
    putlog "sitestat: de-authorizing users"
    foreach vee $vees {chattr $vee -V}
  }
  fbe::FLUSH force
  restart
}

proc antiidle {} {
  global idlestamp anti_idle site
  if {$anti_idle <= 0} {return}
  set blah $site(home)
  putlog "bot: anti-idle to $blah"
  set aidle [expr $anti_idle + [rand 5]]
  putserv "PRIVMSG $blah :.o{$aidle}o."
  utimer [expr $aidle*60] antiidle
}

proc scrondito {} {
	global stasks site bot ulprocess laststamp
	set spk $stasks(spk)
	set now [clock format [clock seconds] -format "%H:%M"]
	foreach {id ts} $spk {
		if {![string match $ts $now] || $laststamp == $now} {continue}
		set cmd [lindex $stasks($id) 1]
putlog "sitestat: scheduled announce commencing..."
		foreach chan [lindex $stasks($id) 0] {
			sitestat $chan _ _ $chan $cmd
		}
	}
	set laststamp $now
}

####  STARTUP CHECKS & TIMERS
set ftpr 0
if {![info exists FLVER] || [string range $FLVER 0 2] != "4.5"} {die "sitestat: CRITICAL : missing or incorrect version of ss-ftplib.tcl"}
if {![info exists FBEVER ] || [string range $FBEVER 0 2] != "5.0"} {die "sitestat: CRITICAL : missing or incorrect version of ss-fbelib.tcl"}
putlog "sitestat: loading..."
ssc {} {}
reconfig {} {} {}
if ![info exists annl] {set annl -3}
set totalspace [expr 1024 * $totalspace]
set curtimers [utimers]
if {$anti_idle > 0 && ![regexp "antiidle" $curtimers]} {putlog "bot: loading anti-idle" ; utimer 600 antiidle}
if ![regexp "backupdate" $curtimers] {
  utimer 300 backupdate 
  putlog "sitestat: event cycles loaded"
  set vees [userlist V]
  foreach vee $vees {chattr $vee -V}
  fbe::CLEAN force
}
set ftprocess 0
ftp_login

putlog "$ssver loaded"

